// root is jquery object root.show()
// plugin.method()
// setting : setting.value
// variable : variable

(function($) {
	//----------------------------------------------------------plugin class
    $.viwcol = function(target, options) {
	//--------------------------------------------------------variable
		var plugin = this;
		
		var root=$(target);
		
		var interval=0;
		
		var _clScopeTarget ;
		
		var _sdisplaymodeui ;
		

	//--------------------------------------------------------settings
		var settings = {
			scope: null,
			data: [],
			datachild: [],
			scopetemplate:null
		};   
	
	//--------------------------------------------------------constructor
		plugin.init = function(options) {
			settings= $.extend(settings, options); 
			plugin.creation();
			
			var content = new Object();
			
			content["content"] = "Hello world";
			content["shape"] = "";
			content["style"] = "3d";
			content["size"] = "4";
			content["zdepth"] = "3";
			
			plugin.update_bgcolor_ui();
		}
		
		
	//-------------------------------------------------------public function
		plugin.getType = function() {
			return "col";
		}
		
		plugin.creation = function() {
			
			var content = root.html();
			
			plugin.create_widgets (settings.datachild);
			plugin.initbutton();
		}
		
		plugin.get_data = function() {
			return settings.data;
		}
		
		plugin.set_data = function(data) {
			settings.data=data;
		}
		
		plugin.create_widgets = function(content) {
			
			for (var i=0; i<content.length; i++){
				
				var o = content[i];
				var data = o["data"];
				var thecontent = o["content"];
				data["content"]=thecontent;
				plugin.create_widget(o["type"], data);
			}
		}
		
		plugin.create_widget = function(type, content) {
			var id = viwutils.getuniqueID();
			var s= '<div class="viw_ui-widget-container" id="'+id+'" data-jqid="'+id+'" data-type="'+type+'" >widget</div>';
			root.append( s );
			
			var objjq = $("#"+id).viwwidget({
				scope: this,
				data: content,
				scopetemplate : settings.scopetemplate
			
			}).data("viwwidget");
			
			settings.scopetemplate.add_refjq(id, objjq);
			
			return objjq;
		}
		
		plugin.duplicate_widget = function(id) {
			var objjq = settings.scopetemplate.get_refjq(id);
			var objjqsettings = objjq.get_settings_x("data");
			var objjqtype = objjq.get_type();
			
			plugin.create_widget(objjqtype, objjqsettings);
			plugin.update_row();
			// dnd_rebuild_widths();
			viw_visual_wizard.generate_content_from_working_space();
		}
		
		plugin.delete_widget = function(id) {
			var objjq = $("#"+id, root);
			var objjq2 = settings.scopetemplate.get_refjq(id);
			objjq2.killer();
			objjq.remove();
			// remove obj ref
			settings.scopetemplate.del_refjq(id);
			
			plugin.update_row();
			
			viw_visual_wizard.generate_content_from_working_space();
		}
		
		plugin.initbutton = function() {
			var scoperoot = root;
			var myid = root.data("jqid");
			var mytype = root.data("type");
			
			var urlatt = VIWPROP.root_admin + 'shortcode_selector.php?action=new&widget_type='+mytype+'&widget_id='+myid;
			
			
			$('.viw_ui-add_widget', root).click(function(){
				//console.log("add widget !!!!!!!!!!!!!!!");
				var $parent = this;
				
				$.ajax({
				type: "GET",
				cache: false,
				url: urlatt, // preview.php
			  //data: $("#postp").serializeArray(), // all form fields
				dataType: 'text',
				success: function (data) {
					
					// on success, post (preview) returned data in fancybox
					$.fancybox(data, {
						// fancybox API options
						'orig': $parent,
						'transitionIn':'elastic',
						'transitionOut':'elastic',
						fitToView: false,
						'height':'100%',
						'width':'70%',
						  autoScale: true,
						  autoDimensions: false,
						  autoSize: true,
						  closeClick: false,
						  openEffect: 'none',
						  closeEffect: 'none',
						  padding: 0, // remove white border
						  'showCloseButton':false
					}); // fancybox
					
					plugin.prepare_modal();
					
				  } // success
				}); // ajax
			});	
			
			// edit col
			$('.viw_ui-col-edit', root).click(function(e){
				e.preventDefault(); 
				plugin.edit_col();
			});	
		}
		
		plugin.edit_col = function() {
			//console.log("edit col");
			viw_visual_wizard.open_modal(root,"col",settings);
		}
		
		plugin.prepare_modal = function() {
			$('.vwi_modal_bt_insert_widget').click(function(e){
				e.preventDefault();
				//console.log("clic on modal !!!");
				plugin.check_modal($(this).data("type"));
				
				
			});	
		}
		
		plugin.check_modal = function(type) {
			//console.log("col check modal "+type);
			var data = new Array();
			var objjq = plugin.create_widget(type, data);
			plugin.update_row();
			$.fancybox.close();
			var interval=setTimeout(function(){objjq.edit_widget()},1000);
			
		}
		
		//***************************************
		// PUBLIC
		//***************************************
		
		plugin.setScopeTarget= function(scope) {
			_clScopeTarget = scope;
		}
	
		
		plugin.killer= function() {
			// plugin.stopAnim();
			
			var scoperoot = root;
			var scopetemplate = settings.scopetemplate;
			root.children('.viw_ui-widget-container').each(function(){
				var id = $(this).data("jqid");
				var objjq = scopetemplate.get_refjq(id);
				objjq.killer();
			});
			settings = null;
			root.empty();
		}
		
		plugin.update_displaymodeui= function(mode) {
			 _sdisplaymodeui = mode;
			var scopetemplate = settings.scopetemplate;
			// update all row
			root.find('.viw_ui-widget-container').each(function(){
				var id = $(this).data("jqid");
				var objjq = scopetemplate.get_refjq(id);
				objjq.update_displaymodeui(mode);
			});
			
			plugin.update_forpreview();
		}
		
		
		//***************************************
		// PRIVATE
		//***************************************
		plugin.update_row = function() {
			var myparentid = root.parent().data("jqid");
			var objjqparent = settings.scopetemplate.get_refjq(myparentid);
			objjqparent.rebuild_widths();
		}
		
		// visualwizard.checkmodal()   when col is invisible should recheck the responsive tablet
		plugin.update_row_spanmed = function() {
			//console.log("col : update_row_spanmed ");
			var myparentid = root.parent().data("jqid");
			var objjqparent = settings.scopetemplate.get_refjq(myparentid);
			objjqparent.update_spanmed();
		}
		
		plugin.update_span = function(span) {
			if(root.children('p').length === 0){
				root.append('<p class="viw_ui-col-container-controls viw_clearfix" ></p>');
			}
			
			$(".viw_ui-col-container-controls span", root).html(span+"/12");
			
			root.attr('data-span',span);
			settings.data["span"] = span;
			
		}
		
		// set by row.update_spanmed
		plugin.update_spanmed = function(spanmed, topmed) {
			settings.data["spanmed"] = spanmed;
			settings.data["topmed"] = topmed;
		}
		
		// visual-wizard.js when modal is closed
		plugin.update_bgcolor_ui = function() {
			
			// update the color of the backgroud
			$('.viw_ui-col-container-controls', root).css("background-color",settings.data["bgcolor"]);
			plugin.update_forpreview();
		}
		
		plugin.update_forpreview = function() {
			var mode = _sdisplaymodeui;
			
			if (mode=="likefrontend"){
				
				switch(settings.data["bg_type"]) {
					
					case "color":
						root.css("background-color",settings.data["bgcolor"]);
					break;
					case "photo":
						root.css("background-image","url(../.././data/medias/"+settings.data["bgimage"]+")");
					break;

					default:
						
						//root.css("background-color",settings.data["bgcolor"]);
						
				}
			}
		}
		
		plugin.tracer = function(s) {
			//console.log ("dp-signage-engine: "+s);
		}
		plugin.tracer2 = function(o) {
			//console.dir (o);
		}
		
		
	  
		 //-----------------------------------------------------------initialisation 
		plugin.init(options);
	}	
	//-------------------------------------------------------------plugin inclusion
    $.fn.viwcol = function(options) {
        return this.each(function() {
            if ($(this).data('viwcol') == undefined  ) {
                var plugin = new $.viwcol(this, options);
                $(this).data('viwcol', plugin);
            }
        });
    }
	
})(jQuery);