// root is jquery object root.show()
// plugin.method()
// setting : setting.value
// variable : variable

(function($) {
	//----------------------------------------------------------plugin class
    $.viwsection = function(target, options) {
	//--------------------------------------------------------variable
		var plugin = this;
		
		var root=$(target);
		
		var interval=0;
		
		var _clScopeTarget ;
		
		var _sidscopededcss ;
		var _sdisplaymodeui ;

	//--------------------------------------------------------settings
		var settings = {
			scope: null,
			data: [],
			datachild: [],
			scopetemplate:null
		};   
	
	//--------------------------------------------------------constructor
		plugin.init = function(options) {
			settings= $.extend(settings, options); 
			plugin.creation();
			plugin.do_drag_row();
			plugin.initbutton();
			plugin.update_bgcolor_ui();
		}
	//-------------------------------------------------------public function
		plugin.getType = function() {
			return "section";
		}
		
		plugin.creation = function() {
			
	
			var s= '';
			
			
			
			s += '<div class="viw_ui-section-container-controls viw_clearfix">';
			
				s += '<a class="viw_ui-control-section viw_ui-section-move" href="#" title="'+VIWPROP.loc.L_DRAG_SECTION+'" ><i class="viw_ui-icon"></i></a>';
				
				s += '<a class="viw_ui-control-section viw_ui-section-edit" href="#" title="'+VIWPROP.loc.L_CHANGE_SECTION_PROPS+'" ><i class="viw_ui-icon"></i></a>';
				
				// s += '<a class="viw_ui-control-section viw_ui-section-copy" href="#" title="'+VIWPROP.loc.L_COPY_SECTION+'" ><i class="viw_ui-icon"></i></a>';
				
				s += '<a class="viw_ui-control-section viw_ui-section-delete" href="#" title="'+VIWPROP.loc.L_DELETE_SECTION+'" ><i class="viw_ui-icon"></i></a>';
				
				
				
				s += '<a class="viw_ui-control-section viw_ui-section-toggle" href="#" title="'+VIWPROP.loc.L_TOGGLE_SECTION+'" ><i class="viw_ui-icon"></i></a>';
				
				s += '<span class="viw_ui-control-section viw_ui-section-title" >'+VIWPROP.loc.L_MY_SECTION+'</span>';
				
				
			
			s += '</div>';
			
			//s += '<span class="viw_ui-section-container-toggle" title="Toggle"></span>';
			//s += '<span class="viw_ui-section-container-handler" title="Rearange Sections"></span>';
			
			
			// s += '<div class="viw_ui-add_row-container vwi_flex vwi_flexJustifyCenter vwi_flexAlignItemsEnd" ><span class="viw_ui-add_row" title="Add Row"></span></div>';
			
			root.html(s);
			
			_sidscopededcss = viwutils.getuniqueID();
			var scopestyle = '<style type="text/css" scoped="scoped" id="'+_sidscopededcss+'" ></style>';
			$( scopestyle ).insertBefore( root );
			
			plugin.create_rows (settings.datachild);
		}
		
		plugin.get_data = function() {
			return settings.data;
		}
		
		plugin.set_data = function(data) {
			settings.data=data;
		}
		
		plugin.create_rows = function(content) {
			
			for (var i=0; i<content.length; i++){
				
				plugin.create_row(content[i], false);
			}
		}
		
		plugin.create_row = function(content, bdragwidget) {
			var id = viwutils.getuniqueID();
			var s= '<div class="viw_ui-row-container vwi_flexxx" id="'+id+'" data-jqid="'+id+'" ></div>';
			root.append( s );
			
			var datacontent=content["data"];
			var datachild=content["col"];
			
			var objjq = $("#"+id).viwrow({
				scope: this,
				data: datacontent,
				datachild: datachild,
				scopetemplate : settings.scopetemplate
			}).data("viwrow");
			
			settings.scopetemplate.add_refjq(id, objjq);
			
			if (bdragwidget==true){
				settings.scopetemplate.do_drag_widget();
			}
			
		}
		
		plugin.duplicate_row = function(id) {
			//console.log("section duplicate row !");
			// 1 create row and cols
			// 2 push widget inside col of this row
			// or build a content["data"] and content["col"]
			// and plugin.create_row(content);
			/*
			var objjq = settings.scopetemplate.get_refjq(id);
			
			plugin.create_row(objjqtype, objjqsettings);
			plugin.update_row();
			// dnd_rebuild_widths();
			viw_visual_wizard.generate_content_from_working_space();
			*/
		}
		
		plugin.delete_row = function(id) {
			//console.log("section delete row id="+id);
			var objjq = $("#"+id, root);
			var objjq2 = settings.scopetemplate.get_refjq(id);
			objjq2.killer();
			objjq.remove();
			// remove obj ref
			settings.scopetemplate.del_refjq(id);
			
			// plugin.update_row();
			
			viw_visual_wizard.generate_content_from_working_space();
		}
		
		plugin.do_drag_row = function() {
			
			root.sortable({ 
				
				items: "> .viw_ui-row-container", 
				handle: ".viw_ui-row-move", 
				revert: true, 
				axis: "y", 
				cursor: "move", 
				tolerance: "pointer",
				stop: function(){
					//dnd_rebuild_widths();
					viw_visual_wizard.generate_content_from_working_space();
				},
				
				update: function(e, ui){
					
					if (ui.item.hasClass( "viw_sidebar-ui_widgetsystem-container-row" )) {
						
						plugin.create_row_from_sidebar(ui);
					}
				},
				// over: dnd_rebuild_widths
			});
		
			root.disableSelection();
			
		}
		
		// create widget com from sidebar
		plugin.create_row_from_sidebar = function(ui) {
			
			var objname=$(ui.item).data("type");
			var content = new Object();
			content = VIWPROP.widget[objname].default_options;
			var id = viwutils.getuniqueID();
			
			ui.item
				.switchClass( "viw_sidebar-ui_widget-container", "viw_ui-row-container" )
				.removeClass("viw_sidebar-ui_widgetsystem-container")
				.attr('id', id)
				.attr('data-jqid', id)
				.removeAttr ("style")
				.html ("row");
			
			// object or array ?
			var datachild = [];
			
			datachild[0] = new Array();
			datachild[0]["data"] = new Object();
					datachild[0]["data"]["span"]=12;
					datachild[0]["widget"] = new Array();
			
			var objjq = $("#"+id).viwrow({
				scope: this,
				data: content,
				datachild: datachild,
				scopetemplate : settings.scopetemplate
			}).data("viwrow");
			
			settings.scopetemplate.add_refjq(id, objjq);
			settings.scopetemplate.do_drag_widget();
			
		}
		
		
		//***************************************
		// PUBLIC
		//***************************************
		
		plugin.setScopeTarget= function(scope) {
			_clScopeTarget = scope;
		}
	
		plugin.killer= function() {
			var scopetemplate = settings.scopetemplate;
			root.children('.viw_ui-row-container').each(function(){
				var id = $(this).data("jqid");
				var objjq = scopetemplate.get_refjq(id);
				objjq.killer();
			});
			settings = null;
			root.empty();
		}
		
		// come from fullscreen ex 
		// viw_visual_wizard.prototype.update_section
		plugin.update= function() {
			
			var scopetemplate = settings.scopetemplate;
			// update all row
			root.find('.viw_ui-row-container').each(function(){
				var id = $(this).data("jqid");
				var objjq = scopetemplate.get_refjq(id);
				objjq.update();
			});
		}
		
		// come from wireframe btn : wireframe - preview
		plugin.update_displaymodeui= function(mode) {
			 _sdisplaymodeui = mode;
			var scopetemplate = settings.scopetemplate;
			// update all row
			root.find('.viw_ui-row-container').each(function(){
				var id = $(this).data("jqid");
				var objjq = scopetemplate.get_refjq(id);
				objjq.update_displaymodeui(mode);
			});
			
			plugin.update_forpreview();
		}
		
	//***************************************
	// PRIVATE
	//***************************************
		plugin.myprivate = function(s) {
			
		}
		
		plugin.tracer = function(s) {
			//console.log ("dp-signage-engine: "+s);
		}
		plugin.tracer2 = function(o) {
			//console.dir (o);
		}
		
		plugin.initbutton = function() {
			var scoperoot = root;
			$('.viw_ui-section-toggle', root).click(function(e){
				e.preventDefault(); 
				//console.log("click")
				if (scoperoot.hasClass("viw_ui-collapsed-row")){
					scoperoot.removeClass("viw_ui-collapsed-row");
					$('.viw_ui-row-container', root).show();
				} else{
					scoperoot.addClass("viw_ui-collapsed-row");
					$('.viw_ui-row-container', root).hide();
				
				}
				// 
			});	
			
			// edit section
			$('.viw_ui-section-edit', root).click(function(e){
				e.preventDefault(); 
				plugin.edit_section();
			});
			
			// delete section
			$('.viw_ui-section-delete', root).click(function(e){
				e.preventDefault(); 
				//console.log("delete section !!!!");
				plugin.delete_section();
			});
			
			// copy section
			$('.viw_ui-section-copy', root).click(function(e){
				e.preventDefault(); 
				//console.log("copy section !!!!");
				//plugin.edit_section();
			});

			/*
			$('.viw_ui-add_row', root).click(function(e){	
				e.preventDefault(); 
				//console.log("add row");
				var content = new Array();
				content["data"] = new Object();
				content["col"] = new Array();
					content["col"][0] = new Array();
					content["col"][0]["data"] = new Object();
					content["col"][0]["data"]["span"]=12;
					content["col"][0]["widget"] = new Array();
				
				
				plugin.create_row (content, true);
				
			});	
			*/
			
			
		}
		
		plugin.edit_section = function() {
			//console.log("edit section new !!!");
			viw_visual_wizard.open_modal(root,"section",settings);
		}
		
		
		plugin.delete_section = function() {
			//console.log("delete section ");
			var myid = root.data("jqid");
			//console.log("delete section !!!"+myid);
			settings.scopetemplate.delete_section(myid);
			//objjqparent.delete_section (myid);
			
		}
		
		/*
		plugin.edit_sectionOLD = function() {
			var scoperoot = root;
			var myid = root.data("jqid");
			var mytype = "section";
			var datawidget = settings.data;
			datawidget["content"]= viwutils.rawurldecode(datawidget["content"]);
			var o = new Object();
			o["widget"]= new Object();
			o["widget"] = datawidget;
			
			var $parent = root;
			
			$.ajax({
				type: "POST",
				cache: false,
				url: 'http://secretsitebox.fr/themesspx/dev/visualwizard/plugins/spxvisualwizard/admin/shortcode_attributes.php?action=edit&widget_type='+mytype+'&widget_id='+myid, // preview.php
			 
				dataType: 'text',
				data: o,
				success: function (data) {
					// on success, post (preview) returned data in fancybox
					$.fancybox(data, {
					  // fancybox API options
					'orig': $parent,
					'transitionIn':'elastic',
					'transitionOut':'elastic',
					  fitToView: false,
						'height':'100%',
						'width':'70%',
					  autoScale: true,
					  autoDimensions: false,
					  autoSize: true,
					  closeClick: false,
					  openEffect: 'none',
					  closeEffect: 'none',
					  padding: 0, // remove white border
					  'showCloseButton':false
					}); // fancybox
					
					plugin.prepare_modal();
					
				  } // success
			}); // ajax
			
		}
		
		plugin.prepare_modal = function() {
			plugin.update_preview();
			
			$('#vwi_modal_bt_insert_widget').click(function(e){
				e.preventDefault();
				plugin.check_modal();
				$.fancybox.close();
			});	
			
			$('#vwi_modal_bt_close').click(function(e){
				e.preventDefault();
				$.fancybox.close();
			});	
			
			// need to change the method
			$('#id_vwi_ui-modal-content-left').height($('.vwi_ui-modal-container-content').height()-50);
			
			$( ".vwi_ui_elementchange" ).change(function() {
				plugin.checkcolorneeddarkandlight($( this ));
				plugin.update_preview();
			});
			
			//$(".needselect2").select2();
			
			$('.colorneeddarkandlight').each( function(i) {
				plugin.checkcolorneeddarkandlight ($( this ));
			});
		}
		
		plugin.checkcolorneeddarkandlight = function(elem) {
			if (elem.hasClass( "colorneeddarkandlight" ) ) {
				plugin.changecolorneeddarkandlight(elem);
			}
		}
		
		plugin.changecolorneeddarkandlight = function(elem) {
			var id = $( elem ).prop( "id" );
			var color = $( elem ).val();
			$( "#"+id+"_dark" ).val(tinycolor(color).darken().toString());
			$( "#"+id+"_light" ).val(tinycolor(color).lighten().toString());
		}
		
		plugin.check_modal = function() {
			var oform = $( "#vwi_modal_form_attribute" ).serializeArray();
			// transform array form to object
			var bgcolor="#fff";
			var odata = new Object();
			for (var i=0; i<oform.length; i++){
				var name = oform[i]["name"];
				var val = oform[i]["value"];
				if (name=="bgcolor") bgcolor = val;
				if (name == "content") {
					plugin.update_title(val);
					val = viwutils.rawurlencode(val);
				}
				odata[name]=val;
			}
			
			var widget_id = $( "#vwi_modal_form_attribute #id_widget_id" ).val();
			settings.data = odata;
			
			plugin.update_bgcolor_ui();

			viw_visual_wizard.generate_content_from_working_space();
		}
		
		plugin.update_preview = function() {
			var scoperoot = root;
			var datawidget = settings.data;
			
			var widget_type = "section";
			var widget_id = root.data("jqid");
			
			var oform = $( "#vwi_modal_form_attribute" ).serializeArray();
			// transform array form to object
			var odata = new Object();
			for (var i=0; i<oform.length; i++){
				var name = oform[i]["name"];
				var val = oform[i]["value"];
				odata[name]=val;
			}
			var o = new Object();
			o["widget"]= new Object();
			o["widget"] = odata;
			
			
			$.ajax({
				type: "POST",
				cache: false,
				url: 'http://secretsitebox.fr/themesspx/dev/visualwizard/plugins/spxvisualwizard/admin/modal_preview.php?action=edit&widget_type='+widget_type+'&widget_id='+widget_id, 
				dataType: 'text',
				data: o,
				success: function (data) {
					$( "#id_vwi_ui-modal-content-right" ).html(data);
				  } // success
			}); // ajax
		}
		*/
		plugin.update_bgcolor_ui = function() {
			// update the color of the backgroud
			$('.viw_ui-section-container-controls', root).css("background-color",settings.data["bgcolor"]);
			plugin.update_title_ui();
			plugin.update_forpreview();
		}
		
		plugin.update_title_ui = function() {
			// update the title of the section
			$('.viw_ui-section-title', root).html(settings.data["title"]);
		}
		
		plugin.update_forpreview = function() {
			var mode = _sdisplaymodeui;
			//console.log("section update_forpreview "+mode+" bg type="+settings.data["bg_type"]);
			//console.dir(settings.data);
			// root.css("background-color","green");
			
			root.removeClass ("vwi_flex vwi_flexCol vwi_flexWrap vwi_flexAlignItemsStretch vwi_flexAlignItemsStart vwi_flexAlignItemsEnd vwi_flexJustifyCenter vwi_flexJustifyBetween vwi_flexJustifyAround");
				
			if (mode=="likefrontend"){
				// console.dir(settings);
				switch(settings.data["bg_type"]) {
					case "particule" :
					case "color":
						root.css("background-color",settings.data["bgcolor"]);
						break;
					case "photo":
					case "parallax":
					case "segmenter" :
						root.css("background-image","url(../.././data/medias/"+settings.data["bgimage"]+")");
					
					break;
					
					default:
						root.css("background-color",settings.data["bgcolor"]);
						
				}
				
				
				/* width 
				
				if ($width == "fixed"){
					//$cssstyle .= 'max-width: 1280px;';
					$cssstyle .= 'max-width: '.VIW_CONTAINERWIDTH.'px;';
				}
					$cssstyle .= 'width: 100%;';*/
				if (settings.data["row_alignement"] != 'default' && settings.data["row_alignement"] !== undefined){
					var rawalign = settings.data["row_alignement"] ;
					root.addClass ("vwi_flex vwi_flexCol vwi_flexWrap vwi_flexAlignItemsStretch "+rawalign);
				}
				if (settings.data["height"] == 'fullheight'){
					var h = $(window).height();
					root.css({'min-height':h+'px'});
				}
				
				
				
				
			} else {
				root.removeAttr("style");
			}
			
			switch(mode) {
				case "preview":	
				case "likefrontend":
					var scopecss = '';
					var headingcolor = settings.data["headingcolor"];
					var textcolor = settings.data["textcolor"];
					var linkcolor = settings.data["linkcolor"];
					var linkhovercolor = settings.data["linkhovercolor"];
					var headingcolor = settings.data["headingcolor"];
					var textalign = settings.data["textalign"];
					
					var uniqid = root.data("jqid");
					
					if (textalign != '')  scopecss += '#'+uniqid+' { text-align:'+textalign+';}';
					if (headingcolor != '') scopecss += '#'+uniqid+' h1, #'+uniqid+' h2, body #'+uniqid+' h3, #'+uniqid+' h4, #'+uniqid+' h5, #'+uniqid+' h6 { color:'+headingcolor+';}';
					// a color
					if (textcolor != '')  scopecss += '#'+uniqid+' { color:'+textcolor+';}';
					if (linkcolor != '')  scopecss += '#'+uniqid+' a { color:'+linkcolor+';}';
					// a hove color
					if (linkhovercolor != '')  scopecss += '#'+uniqid+' a:hover { color:'+linkhovercolor+';}';
				
					$("#"+_sidscopededcss).html(scopecss);
					break;
				case "wireframe":
				default:
					$("#"+_sidscopededcss).html("");
					break;
				
			}
		}
		
		
		
		  //-----------------------------------------------------------initialisation 
			plugin.init(options);
		}	
	//-------------------------------------------------------------plugin inclusion
    $.fn.viwsection = function(options) {
        return this.each(function() {
            if ($(this).data('viwsection') == undefined  ) {
                var plugin = new $.viwsection(this, options);
                $(this).data('viwsection', plugin);
            }
        });
    }
	
})(jQuery);
	


