// root is jquery object root.show()
// plugin.method()
// setting : setting.value
// variable : variable

(function($) {
	//----------------------------------------------------------plugin class
    $.viwwidget = function(target, options) {
	//--------------------------------------------------------variable
		var plugin = this;
		
		var root=$(target);
		
		var type="";
		
		var _clScopeTarget ;
		var _nIDTimeOut ;
		

		//***************************************
		// SETTINGS
		//***************************************
		var settings = {
			data: []
		};   
	
		//***************************************
		// CONSTRUCTOR
		//***************************************
		plugin.init = function(options) {
			settings= $.extend(settings, options); 
			
			plugin.creation();
			plugin.initbutton();
		}
		//***************************************
		// PUBLIC
		//***************************************
		plugin.creation = function() {
			
			type = root.data("type");
			
			// 
			var s= '';
			s += '<div class="viw_ui-widget-container-controls">';
				
				s += '<a class="viw_ui-control-widget viw_ui-widget-edit" href="#" title="'+VIWPROP.loc.L_CHANGE_WIDGET_PROPS+'" ><i class="fa fa-pencil-square-o" aria-hidden="true"></i></a>';
				
				s += '<a class="viw_ui-control-widget viw_ui-widget-copy" href="#" title="'+VIWPROP.loc.L_COPY_WIDGET+'" ><i class="fa fa-clone" aria-hidden="true"></i></a>';
				
				s += '<a class="viw_ui-control-widget viw_ui-widget-delete" href="#" title="'+VIWPROP.loc.L_DELETE_WIDGET+'" ><i class="fa fa-trash-o" aria-hidden="true"></i></a>';
			
			s += '</div>';
			
			s += '<div class="viw_ui-widget-description" >';
			s += '</div>';
			
			root.html(s);
			
			
			plugin.update_title();
		}
		
		plugin.update_title = function() {
			// http://stackoverflow.com/questions/6045165/calling-function-with-arguments-in-mustache-javascript
			//http://jsfiddle.net/anilkamath87/GBP8N/
			//var contentwidget = viwutils.strip_tags (viwutils.rawurldecode(settings.data["content"]));
			//if (contentwidget==null || contentwidget=="undefined") contentwidget="";
			
			// mode wireframe or preview
			//var mode = "preview";
			
			
			
			var mode = viw_visual_wizard.get_displaymodeui();
			if (mode=="likefrontend") mode="preview";
			var checktpl = "#id_viw_template_widget_"+mode+"_"+type;
			//console.log("check tpl = "+checktpl);
			if ($(checktpl).length>0){
				var tpl = checktpl;
				//console.log("check tpl2 = "+checktpl);
				//console.dir (settings.data);
				var o = viwutils.cloneObject(settings.data);
				// définir plusieurs manip de sortie
				var contentwidget = viwutils.strip_tags (viwutils.rawurldecode(settings.data["content"]));
				if (contentwidget==null || contentwidget=="undefined") contentwidget="";
				// a cause des style= pour le rawhtml
				var contentwidget2 = viwutils.str_replace("&#34;", '"', viwutils.stripslashes(viwutils.rawurldecode(settings.data["content"])));
				
				o.content = contentwidget;
				o.content2 = contentwidget2;
				o.uniqueid = viwutils.getuniqueID();
				o.type = type;
				//console.log("renderer : "+type);
				viwutils.mustacheRender(tpl, o, $('.viw_ui-widget-description', root));
				
			}else{
				var contentwidget = viwutils.strip_tags (viwutils.rawurldecode(settings.data["content"]));
				if (contentwidget==null || contentwidget=="undefined") contentwidget="";
				var tpl = '#id_viw_template_widget_base';
				viwutils.mustacheRender(tpl, {type: type, content: contentwidget}, $('.viw_ui-widget-description', root));
			}
			
		}
		
		plugin.get_data = function() {
			return settings.data;
		}
		
		plugin.get_settings = function() {
			return settings;
		}
		
		plugin.get_settings_x = function(x) {
			return settings[x];
		}
		
		plugin.get_type = function() {
			return type;
		}
		
		plugin.killer= function() {
			// plugin.stopAnim();
			plugin.clearme();
			settings = null;
			//console.log("on no i'm dead !");
			root.empty();
		}
		
		plugin.update_displaymodeui= function(mode) {
			//console.log("widget update with mode = "+mode);
			plugin.update_title();
		}
		
		//***************************************
		// PRIVATE
		//***************************************
		plugin.initbutton = function() {
			var scoperoot = root;
			// delete widget
			$('.viw_ui-widget-delete', root).click(function(e){
				e.preventDefault(); 
				var myid = scoperoot.data("jqid");
				var myparentid = scoperoot.parent().data("jqid");
				var objjqparent = settings.scopetemplate.get_refjq(myparentid);
				//console.log("delete widget !!!"+myid+" parent id = "+myparentid);
				// get the id of parent
				// get the jqobj
				objjqparent.delete_widget (myid);
			});
			
			// copy widget
			$('.viw_ui-widget-copy', root).click(function(e){
				e.preventDefault();
				//console.log("copy widget !!!");
				var myid = scoperoot.data("jqid");
				var myparentid = scoperoot.parent().data("jqid");
				var objjqparent = settings.scopetemplate.get_refjq(myparentid);
				objjqparent.duplicate_widget (myid);
				
			});	
			
			// edit widget
			$('.viw_ui-widget-edit', root).click(function(e){
				e.preventDefault(); 
				plugin.edit_widget();
			});	
		}
		plugin.edit_widget = function() {
			var scoperoot = root;
			var myid = root.data("jqid");
			var mytype = root.data("type");
			var datawidget = settings.data;
			
			datawidget["content"]= viwutils.rawurldecode(datawidget["content"]);
			
			
			var o = new Object();
			o["widget"]= new Object();
			o["widget"] = datawidget;
			
			//console.log("------------------------------------------------> edit_widget ");
			//console.dir (o);
			
			var widget_type = mytype;
			var widget_id = myid;
			var $parent = root;
			
			var scrollbar_options = {
				theme:'dark-thin',
				scrollInertia: 500
			};
			
			var urlatt = VIWPROP.root_admin + 'shortcode_attributes.php?action=edit&widget_type='+widget_type+'&widget_id='+widget_id;
			
			$.ajax({
				type: "POST",
				cache: false,
				url: urlatt, // 
			  //data: $("#postp").serializeArray(), // all form fields
				dataType: 'text',
				data: o,
				success: function (data) {
					//console.log("widget data back");
					//console.dir(data);
					// on success, post (preview) returned data in fancybox
					$.fancybox(data, {
					  // fancybox API options
					'orig': $parent,
					'transitionIn':'elastic',
					'transitionOut':'elastic',
					  fitToView: false,
						'height':'100%',
						'width':'100%',
					  autoScale: true,
					  autoDimensions: false,
					  autoSize: true,
					  closeClick: false,
					  openEffect: 'none',
					  closeEffect: 'none',
					  padding: 0, // remove white border
					  'showCloseButton':false
					}); // fancybox
					
					plugin.prepare_modal();
					
					
					
				  } // success
			}); // ajax
			
		}
		
		plugin.prepare_modal = function() {
			plugin.update_preview();
			
			
			$('#vwi_modal_bt_insert_widget').click(function(e){
				e.preventDefault();
				//console.log("clic on modal !!!");
				plugin.check_modal();
				
				$.fancybox.close();
			});	
			
			$('#vwi_modal_bt_close').click(function(e){
				e.preventDefault();
				$.fancybox.close();
			});	
			
			// need to change the method
			var containerheight = $('.vwi_ui-modal-container-content').height()-50;
			$('#id_vwi_ui-modal-content-left').height(containerheight);
			$('#id_vwi_ui-modal-content-right').height(containerheight);
			// $('#id_vwi_ui-modal-content-right .viw_ui-modal-preview-container').height(containerheight);
			// $('#id_vwi_ui-modal-content-right .viw_ui-modal-preview-container').css("min-height",containerheight); 
			
			/*
			$( "#id_vwi_ui-modal-content-left" ).resizable({
				//handles: 's',
				handles: 'e',
				
				start: function( event, ui ) {
					
				},
				
				resize: function( event, ui ) {
					var nextel = ui.element.next();
					console.log("next element = "+nextel);
					var w  = $( ".vwi_ui-modal-content" ).width() - ui.element.width()-100;
					nextel.width(w);
				},
				
				stop: function(event, ui) {
					//$(this).css("width", '');
			   }
			
			
				}).on('resize', function (e) {
					e.stopPropagation();
			});
			*/
			
			/*
			$('.viw_ui-modal-col-container').matchHeight({
					byRow: true,
					property: 'height',
					target: null,
					remove: false
				}
			);
			*/
			
			
			
			
			$( ".vwi_ui_elementchange" ).change(function() {
				//alert( "Handler for .change() called." );
				// update the preview
				plugin.checkcolorneeddarkandlight($( this ));
				plugin.update_preview();
			});
			
			
			//https://gist.github.com/brandonaaskov/1596867
			/*$('.vwi_ui_elementchange').on('input', function(){
				plugin.checkcolorneeddarkandlight($( this ));
				plugin.update_preview();
			});*/
			
			
			
			//$(".needselect2").select2();
			
			
			$('.colorneeddarkandlight').each( function(i) {
				plugin.checkcolorneeddarkandlight ($( this ));
			});
			
			
		}
		
		
		plugin.checkcolorneeddarkandlight = function(elem) {
			//console.log("checkcolorneeddarkandlight");
			
			if (elem.hasClass( "colorneeddarkandlight" ) ) {
				//console.log("j'ai dark et lignht");
				plugin.changecolorneeddarkandlight(elem);
		 
			}
		}
		
		plugin.changecolorneeddarkandlight = function(elem) {
			var id = $( elem ).prop( "id" );
			var color = $( elem ).val();
			$( elem ).css ("background-color",color);
			//console.log("id="+id);
			$( "#"+id+"_dark" ).val(tinycolor(color).darken().toString());
			$( "#"+id+"_light" ).val(tinycolor(color).lighten().toString());
		}
		
		
		plugin.survey = function(selector, callback) {
			console.log("survey");
			   var input = $(selector);
			   var oldvalue = input.val();
			   setInterval(function(){
				  if (input.val()!=oldvalue){
					  oldvalue = input.val();
					  callback();
				  }
			   }, 100);
		}
		
		plugin.check_modal = function() {
			//console.log("check modal");
			var oform = $( "#vwi_modal_form_attribute" ).serializeArray();
			var scontent = "";
			// transform array form to object
			var odata = new Object();
			for (var i=0; i<oform.length; i++){
				var name = oform[i]["name"];
				var val = oform[i]["value"];
				val = viwutils.replacequotetoasc(val);
				if (name == "content") {
					scontent = val;
					//plugin.update_title(val);
					val = viwutils.rawurlencode(val);
				}
				odata[name]=val;
			}
			
			//console.dir( oform );
			var widget_id = $( "#vwi_modal_form_attribute #id_widget_id" ).val();
			//console.log("widget id ="+widget_id);
			//console.log("check modal 2");
			//console.dir( settings.data );
			settings.data = odata;
			
			plugin.update_title();
			
			viw_visual_wizard.generate_content_from_working_space();
			
		}
		
		// clear current process
		plugin.clearme = function() {
			clearTimeout(_nIDTimeOut);
		}
		
		plugin.update_preview = function() {
			plugin.clearme();
			_nIDTimeOut = setTimeout(function(){
				plugin.update_preview2();
			}, 500);
		}
		plugin.update_preview2 = function() {
			
			var scoperoot = root;
			var datawidget = settings.data;
			/*
			var o = new Object();
			o["widget"]= new Object();
			o["widget"] = datawidget;
			*/
			var widget_type = root.data("type");
			var widget_id = root.data("jqid");
			
			
			// viwutils::replaceallquotesinform("vwi_modal_form_attribute");
			var oform = $( "#vwi_modal_form_attribute" ).serializeArray();
			// transform array form to object
			var odata = new Object();
			for (var i=0; i<oform.length; i++){
				var name = oform[i]["name"];
				var val = oform[i]["value"];
				val = viwutils.replacequotetoasc(val);
				odata[name]=val;
			}
			var o = new Object();
			o["widget"]= new Object();
			o["widget"] = odata;
			
			
			var urlprev = VIWPROP.root_admin + 'modal_preview.php?action=edit&widget_type='+widget_type+'&widget_id='+widget_id+'&random='+viwutils.getuniqueID();
			
			$.ajax({
				type: "POST",
				cache: false,
				url: urlprev, 
				dataType: 'text',
				data: o,
				success: function (data) {
					//console.log("widget previw");
					//console.dir(data);
					$( "#id_vwi_ui-modal-content-right" ).html(data);
				  } // success
			}); // ajax
		}
		
		plugin.tracer = function(s) {
			//console.log ("dp-signage-engine: "+s);
		}
		plugin.tracer2 = function(o) {
			//console.dir (o);
		}
	  
		//-----------------------------------------------------------initialisation 
		plugin.init(options);
	}	
	//-------------------------------------------------------------plugin inclusion
    $.fn.viwwidget = function(options) {
        return this.each(function() {
            if ($(this).data('viwwidget') == undefined  ) {
                var plugin = new $.viwwidget(this, options);
                $(this).data('viwwidget', plugin);
            }
        });
    }
	
})(jQuery);
	


