// http://arnique.net/web-design/73/a-cool-use-of-regex-extracting-and-displaying-icon-fonts-like-font-awesome/

var viwfont = function() {
   
   
    return {
        
		// Main function
        loadIcons: function(path) {
			$.ajax({
			url: path,
			dataType: "text",
			success: function(data) {
			  //viwfont.loadSheet(path);
			  var s = viwfont.parseCss(data);
			  // console.log(s);
			  
			  $('.fa-set.icon-set').html(s);
			},
			error: function(error) {
			  console.log(error.statusText);
			}
		  });
		},
		
		
		// CSS parser
		parseCss: function(text) {
			// Declare our regex object. "m" flag enables a multi line search
			var regex = /\.([\w-]+):before\s*{\s*content:\s*(["']\\\w+["']);*\s*}/gm;
			var listMarkup = "<ul>";
			var match;
		  
			while (match = regex.exec(text)) {
				var name = match[1];  // class name is at index 1
				name = "fa "+name;
				var code = match[2]; // code at index 2
				//code = code.substring(1,code.length);
				code = code.replace(/\//g, '');
				//listMarkup += "<li><i class='" + name + "'></i></li>";           
			
				listMarkup += '<li data-code='+code+' data-class="'+name+'" class="'+name+'"></li>';
			
			}
		  
			listMarkup += "</ul>";
		  
			return listMarkup;
		},

		// Stylesheet loader
		loadSheet: function(path) {
			var similar = 0;
			$("link").each(function(e) {
				if($(this).attr("href") == path) similar++;
			});
		  
			if(similar == 0) {
				$('<link>').attr('rel','stylesheet')
					.attr('type','text/css')
					.attr('href',path)
					.appendTo('head');
			}
		},
		
    }
}();