function viw_visual_wizard(){
	this.$classic_editor = "";
	this.nclassic_editor_width = 0;
	
	
	this.$working_space = "";
	this.$toolbar = "";
	
	this.$template = "";
	
	this.refjqtemplate = "";
	this.refjqsidebar = "";
	
	/* just for preview part */
	this.$preview_myroot = "";
	this.spreview_widget_type = "";
	this._nIDTimeOut ;
	
	this.sdisplaymodeui ;
	
	this._nWaitIntKC = "";
	
};

/*----------------------------------------------------*/
/*	INIT
/*----------------------------------------------------*/
viw_visual_wizard.prototype.init=function(){
	if($('#article').length>0 && VIWPROP.config.viwpost==1){
		this.load_font();
		this.build_gui();
	} else if ($('#statique').length>0 && VIWPROP.config.viwpage==1){
		this.load_font();
		this.build_gui();
	} else if ($('#categorie').length>0 && VIWPROP.config.viwcategorie==1){
		this.load_font();
		this.build_gui();
	}
}

/*----------------------------------------------------*/
/*	BUILD GUI
/*----------------------------------------------------*/
viw_visual_wizard.prototype.build_gui=function(){
	var scope = this;
	
	$("body > .main.grid").addClass("visualwizard");
	// text area
	this.$classic_editor = $("#id_content");
	this.nclassic_editor_width = this.$classic_editor.width();
	this.$classic_editor.css("resize", "vertical");
	
	this.build_switch_button();
	
	// only for pluxml
	//$(".inline-form.action-bar").css("z-index","500");
	
	// master div
	
	var s = '<div class="viw_sidebar-ui" role="navigation" id="viw_sidebar-ui">toto</div>';
	
	s += '<div id="viw_visual_wizard_ui" class="" >';
	
	
			
			// inside div
			s += '<div class="viw_inside_ui" >';
					// navbar 
					s += '<div class="viw_navbar" role="navigation" id="viw_navbar"></div>';
					// sidebar
					
						/*
						s += '<div class="viw_clearfix" ></div>';
					
						s += '<div class="viw_sidebar-ui" role="navigation" id="viw_sidebar-ui">toto</div>';
						// container ui
						s += '<div style="width:90%" class="viw_container_ui viw_pull-left" >';
							// content (row...)
							s += '<div id="viw_content_ui" class="viw_content_ui" ></div >';
						s += '</div >';
					
						s += '<div class="viw_clearfix" ></div>';
						*/
						
						s += '<div class="viw_container_ui" >';
							// content (row...)
							s += '<div id="viw_content_ui" class="viw_content_ui" ></div >';
						s += '</div >';
					
					
			s += '</div >';		
	s += '</div>';
	this.$classic_editor.after(s);
	this.$working_space = $("#viw_visual_wizard_ui");
	this.$toolbar = $("#viw_navbar");
	this.$sidebar =  $("#viw_sidebar-ui"); 
	
	this.$template = $("#viw_content_ui");
	
	this.build_toolbar();
	
	//this.active_savepage_button();
	this.active_fullscreen_button();
	this.init_display_mode();
	this.check_workingspace_width();
	
	$( window ).resize(function() {
		scope.update_workingspace_width();
	});
	
	// at this step ....
	$("#viw_content-viw").click();
}

viw_visual_wizard.prototype.build_switch_button=function(){
	var scope = this;
	// button to switch
	var s = '<a id="viw_content-viw" class="viw_switch_editor" >Visual Wizard</a>';
	s += '<a id="viw_content-classic" class="viw_switch_editor viw_switch-viw" >Visual</a>';
	this.$classic_editor.before( s );

	$("#viw_content-classic").click(function(e){
		e.preventDefault();
			
			//$dd_classic_editor.show();
			$(this).addClass( "viw_switch-viw" );
			$("#viw_content-viw").removeClass( "viw_switch-viw" );
			
			scope.$classic_editor.show();
			$("#viw_visual_wizard_ui").hide();
		});
		
	$("#viw_content-viw").click(function(e){
		e.preventDefault();
			
			$(this).addClass( "viw_switch-viw" );
			$("#viw_content-classic").removeClass( "viw_switch-viw" );
			
			scope.$classic_editor.hide();
			$("#viw_visual_wizard_ui").show();
			//tinymce.triggerSave();
			//dnd_activate_dd('switch');
			scope.generate_working_space_from_content();
	});
}

viw_visual_wizard.prototype.build_toolbar=function(){
	// button to switch
	var s = '<div class="viw_navbar-header">';
	
		// logo
		s +='<a id="vc_logo" class="viw_navbar-brand" title="Visual Wizard" href="#" target="_blank">Visual Wizard</a></div>';
		
		s +='<ul class="viw_navbar-nav">';
			// left side
			//s +='<li class="viw_show-mobile"><a href="javascript:;" class="viw_icon-btn viw_element-button" data-model-id="vc_element" id="vc_add-new-element" title="Add new element">	</a></li>';
			//s +='<li><a href="javascript:void();" class="viw_icon-btn viw_templates-button viw_navbar-border-right" id="viw_templates-editor-button" title="Templates"></a></li>';
			
			//s +='<li><a href="javascript:void();" class="viw_icon-btn viw_ui_wireframe-button viw_navbar-border-right" id="viw_ui_wireframe-button"  title="Change display mode"></a></li>';
			
			// right side
			s +='<li class="viw_show-mobile viw_pull-right"><a id="viw_ui_fullscreen-button" class="viw_icon-btn viw_ui_fullscreen-button" title="'+VIWPROP.loc.L_FULLSCREEN+'"></a></li>';
			
			//s +='<li class="viw_show-mobile viw_pull-right"><a id="viw_ui_savepage-button" class="viw_icon-btn viw_ui_savepage-button" title="Savepage"> Save</a></li>';
			
			//s +='<li class="viw_pull-right"><a id="viw_post-settings-button" href="javascript:;" class="viw_icon-btn viw_post-settings" title="Page settings"></a></li>';
			
		s +='</ul>';
	
	
	this.$toolbar.append(s);
}
/* UPDATE ALL GUI */
/*
viw_visual_wizard.prototype.update_workingspace_width=function(){
	$(".viw_sidebar-ui_content").perfectScrollbar('update');
}
*/



// working space width
viw_visual_wizard.prototype.update_workingspace_width=function(){
	this.check_workingspace_width();
	this.update_section();
}

viw_visual_wizard.prototype.check_workingspace_width=function(){
	if (this.$working_space.hasClass( "viw_ui-fullscreen" )){
		this.$working_space.css("width","100%");
	}else{
		//this.$working_space.css("width",this.$classic_editor.width());
		this.$working_space.css("width",this.nclassic_editor_width);
	}
}

// savepage
viw_visual_wizard.prototype.savepage=function(jqbutton, jqloader){
	jqbutton.attr('disabled', true);
	jqloader.show();
	
	var page_id = VIWPROP.page_id;
	var page_type = VIWPROP.page_type;
		
	var o = new Object();
	o["content"]= this.$classic_editor.val();
	
	var urlatt = "";
	
	switch(page_type) {
    case "article":
		console.log("save article !!!!");
		var urlatt = VIWPROP.root_admin + 'record_article.php?page_id='+page_id+'&page_type='+page_type;
        break;
    case "statique":
        console.log("save static !!!!");
		var urlatt = VIWPROP.root_admin + 'record_page.php?page_id='+page_id+'&page_type='+page_type;
        break;
	 case "categorie":
        console.log("save cat !!!! page id="+page_id);
		var urlatt = VIWPROP.root_admin + 'record_categorie.php?page_id='+page_id+'&page_type='+page_type;
        // console.log("url = "+urlatt2);
		// http://secretsitebox.fr/themesspx/dev/visualwizard/plugins/spxvisualwizard/admin/record_categorie.php?page_id=001&page_type=categorie
		break;
	}
	/*
	if (page_type=="statique"){
		var urlatt = VIWPROP.root_admin + 'record_page.php?page_id='+page_id+'&page_type='+page_type;
	}else{
		var urlatt = VIWPROP.root_admin + 'record_article.php?page_id='+page_id+'&page_type='+page_type;
	}
	*/
	
	
	//console.dir(o);
	//console.log("url ="+urlatt);
	
	
	if (urlatt != ""){
		$.ajax({
			type: "POST",
			cache: false,
			url: urlatt,
		 
			dataType: 'text',
			data: o,
			success: function (data) {
				//console.dir(data);
				jqbutton.attr('disabled', false);
				jqloader.hide();
			 } // success
		}); // ajax
	}
	
}


// fullscreen
viw_visual_wizard.prototype.active_fullscreen_button=function(){
	var scope= this;
	$("#viw_ui_fullscreen-button", this.$toolbar).click(function(e){
		e.preventDefault();
		if (scope.$working_space.hasClass( "viw_ui-fullscreen" )){
			scope.$working_space.removeClass( "viw_ui-fullscreen" );
			$("#viw_sidebar-ui").removeClass( "viw_ui-fullscreen" );
			scope.killKeepConnection();
		}else{
			scope.$working_space.addClass( "viw_ui-fullscreen" );
			$("#viw_sidebar-ui").addClass( "viw_ui-fullscreen" );
			scope.createKeepConnection();
		}
		
		/*
		scope.check_workingspace_width();
		scope.update_section();
		scope.refjqtemplate.update_width();
		*/
		
		var interval=setTimeout(function(){scope.refresh_modeui()},100);
		
		// fix bug timing
		//var interval=setTimeout(function(){scope.update_section()},5000);
	});
}

viw_visual_wizard.prototype.killKeepConnection = function() {
   clearInterval(this._nWaitIntKC);
}

viw_visual_wizard.prototype.createKeepConnection = function() {
	clearInterval(this._nWaitIntKC);
    var context = this;
    this._nWaitIntKC = setInterval(function() {
        context.loadKeepConnection();
    }, 10000);
}

viw_visual_wizard.prototype.loadKeepConnection = function() {
	var urlatt = VIWPROP.root_admin + 'keepconnected.php' ;
	$.ajax({
		type: "GET",
		url: urlatt,
	}).success(function(result) {
		
	});
}

viw_visual_wizard.prototype.update_section=function(){
	var scope = this;
	var template = $("#viw_content_ui");
	template.find('.viw_ui-section-container').each(function(){
		var id = $(this).data("jqid");
		//console.log("find one section !!! id = "+id);
		var objjq = scope.refjqtemplate.get_refjq(id);
		objjq.update();
	});
}

// wireframe preview mode



viw_visual_wizard.prototype.init_display_mode=function(){
	this.sdisplaymodeui = "wireframe";
	this.$working_space.addClass( "viw_ui-mode_wireframe" );
	var scope= this;
	/*
	$(".viw_ui_wireframe-button", this.$toolbar).click(function(e){
		e.preventDefault();
		scope.change_display_mode($(this));
	});
	*/
	
	/*
	$(".viw_ui_wireframe-button",this.$sidebar).click(function(e){
		e.preventDefault();
		console.log("clic !!!");
		scope.change_display_mode($(this));
	});
	*/
	
}

viw_visual_wizard.prototype.change_display_mode=function(jq){
	var scope= this;
	if (jq.hasClass( "viw_ui_wireframe-button" )){
			jq.removeClass( "viw_ui_wireframe-button" );
			jq.addClass( "viw_ui_preview-button" );
			
			this.$working_space.removeClass( "viw_ui-mode_wireframe" );
			this.$working_space.addClass( "viw_ui-mode_preview" );
			this.sdisplaymodeui = "preview";
			
		}else if (jq.hasClass( "viw_ui_preview-button" )){
			jq.removeClass( "viw_ui_preview-button" );
			jq.addClass( "viw_ui_likefrontend-button" );
			
			this.$working_space.removeClass( "viw_ui-mode_preview" );
			this.$working_space.addClass( "viw_ui-mode_likefrontend" );
			this.sdisplaymodeui = "likefrontend";
		} else{
			jq.removeClass( "viw_ui_likefrontend-button" );
			jq.addClass( "viw_ui_wireframe-button" );
			
			this.$working_space.removeClass( "viw_ui-mode_likefrontend" );
			this.$working_space.addClass( "viw_ui-mode_wireframe" );
			this.sdisplaymodeui = "wireframe";
		}
		this.update_displaymodeui();
		var interval=setTimeout(function(){scope.refresh_modeui()},100);
}

/*
viw_visual_wizard.prototype.init_display_modeOLD=function(){
	this.sdisplaymodeui = "wireframe";
	this.$working_space.addClass( "viw_ui-mode_wireframe" );
	var scope= this;
	$("#viw_ui_wireframe-button", this.$toolbar).click(function(e){
		e.preventDefault();
		if ($(this).hasClass( "viw_ui_wireframe-button" )){
			scope.$working_space.removeClass( "viw_ui-mode_wireframe" );
			scope.$working_space.addClass( "viw_ui-mode_preview" );
			
			$(this).removeClass( "viw_ui_wireframe-button" );
			$(this).addClass( "viw_ui_preview-button" );
			scope.sdisplaymodeui = "preview";
		}else{
			scope.$working_space.removeClass( "viw_ui-mode_preview" );
			scope.$working_space.addClass( "viw_ui-mode_wireframe" );
			
			$(this).addClass( "viw_ui_wireframe-button" );
			$(this).removeClass( "viw_ui_preview-button" );
			scope.sdisplaymodeui = "wireframe";
		}
		scope.update_displaymodeui();
		var interval=setTimeout(function(){scope.refresh_modeui()},100);
	});
}
*/

viw_visual_wizard.prototype.refresh_modeui=function(){
	this.check_workingspace_width();
	this.update_section();
	this.refjqtemplate.update_width();
}

viw_visual_wizard.prototype.update_displaymodeui=function(){
	var scope = this;
	var template = $("#viw_content_ui");
	template.find('.viw_ui-section-container').each(function(){
		var id = $(this).data("jqid");
		var objjq = scope.refjqtemplate.get_refjq(id);
		objjq.update_displaymodeui(scope.sdisplaymodeui);
	});
}

viw_visual_wizard.prototype.get_displaymodeui=function(){
	return this.sdisplaymodeui;
}

// no content message
viw_visual_wizard.prototype.display_no_content=function(){
	// builder add empty div
	var layout_options_out ="<option>Default</default>";
	var s = '';
	s += '<div id="viw_ui-whennocontent">';
		s += '<select name="viw_ui-load_template" id="id_viw_ui-load_template">'+layout_options_out+'</select>';
		s += '<br>or<br><a id="viw_ui-add-section-first">Add Section</a></div>';
	s += '</div>';
	this.$working_space.append(s);

}

viw_visual_wizard.prototype.generate_content_from_working_space=function(){
	$("#viw_visual_wizard_ui").perfectScrollbar('update');
	
	//sections output
	//console.log("generate_content_from_working_space");
	var template = $("#viw_content_ui");
	
	//console.dir(orefjq);
	var scope = this;
	
	var out="";
	var count=0;
	template.find('.viw_ui-section-container').each(function(){
		//console.log("find one section !!!");
		var data = scope.get_data_obj($(this));
		out += "[viw_section ";
		//out += scope.get_data_string (data);
		out += scope.get_data_string_without_default ("section",data);
		
		out += "]";
			// row
			var scope2 = scope;
			$(this).find(".viw_ui-row-container").each(function(){
				//console.log("find row !!!");
				var data = scope2.get_data_obj($(this));
				out += "[viw_row ";
				out += scope2.get_data_string (data);
				out += "]";
				// col
					var scope3 = scope2;
					$(this).find(".viw_ui-col-container").each(function(){
						
						var data = scope3.get_data_obj($(this));
						out += "[viw_col ";
						//var span = $(this).data("span");
						//out += ' span="'+span+'" ';
						out += scope3.get_data_string (data);
						out += "]";
						// widget
						var scope4 = scope3;
						$(this).find(".viw_ui-widget-container").each(function(){
							var data = scope4.get_data_obj($(this));
							var type = $(this).data("type");
							out += "[viw_"+type+" ";
							out += scope4.get_data_string (data);
							out += "]";
							if (data["content"]){
								out += data["content"];
							}
							out += "[/viw_"+type+"]";
						});
						out += "[/viw_col]";	
					});
				
				out += "[/viw_row]";	
			});
		
		out += "[/viw_section]";
	});
	
	this.$classic_editor.val(out);
	//console.log("output = "+out);
	
}

viw_visual_wizard.prototype.get_data_string=function(data) {
	var out='';
	for (var prop in data) {
			// skip loop if the property is from prototype
			//if(!obj.hasOwnProperty(prop)) continue;
			//console.log(prop + " = " + data[prop]);
			if (prop != "content" && prop != "widget_id"){
				out +=  prop+'="'+data[prop]+'" ';
			}
	}
	
	return out;
}

viw_visual_wizard.prototype.get_data_string_without_default=function(widget, data) {
	//console.log("---------------------------get_data_string_without_default---------------------");
	var widget_default = VIWPROP.widget[widget].default_options;
	var out='';
	for (var prop in data) {
			// skip loop if the property is from prototype
			//if(!obj.hasOwnProperty(prop)) continue;
			//console.log("prop "+prop + " = " + data[prop]);
			//console.log("default prop "+widget_default[prop]);
			if (prop != "content" && prop != "widget_id"){
				if (data[prop] != widget_default[prop]){
					out +=  prop+'="'+data[prop]+'" ';
				}
			}
	}
	//console.log("end---------------------------get_data_string_without_default---------------------");
	
	return out;
}


	
viw_visual_wizard.prototype.get_data_obj=function(ref) {
	var id = ref.data("jqid");
	var objjq = this.refjqtemplate.get_refjq(id);
	var data = objjq.get_data();
	return data;
}

viw_visual_wizard.prototype.generate_working_space_from_content=function(){
	content = this.$classic_editor.val();
	//replace single quotes with double and vice versa 
	// (shortcode attributes must have double quotes for parser to work, html content single quotes, and wordpress saves html as double always)
	// content = content.replace(/"/g, '*quot*').replace(/'/g, '"');
	/*
	
	//if there is any content not wrapped properly in section/column structure, show it in first section
	var initial_content = wp.shortcode.replace( 'section_dd', content, function(){return ' ';} ).replace(/&nbsp;/g, ' ').replace(/<p> +<\/p>/g, ' ').trim();
	if(initial_content!==''){
		no_of_sections++;
		output += '<div class="dnd_content_section" data-shortcode="[section_dd]">'+section_handler_icons+'<div class="dnd_column" data-span="12" data-shortcode="[column_dd span=\'12\']">'+column_handler_icons+'<p>12/12</p><div class="dnd_element" title="Text / HTML" data-shortcode="[text_dd]'+initial_content+'[/text_dd]"><span class="element_name">Text / HTML</span>'+element_handler_icon+'</div></div></div>';
	}
	
	*/
	
	
	// do a big array of all shortcode and send it to template
	// template will be instance section
	// section will be instance row
	// row will be instance column
	// column will be instance widget
	// o[0]
	//		["data"] own data
	//		["row"]
	//				[0]
	//					["data"] own data
	//					["column"]
	//						[0]
	//						["data"] own data
	//						["widget"]
	//							[0]
	// 	
	var index = 0;
	var oparsing = new Array();
	//  ******* parse section in current content ******* 
	do{
		current_section = wp.shortcode.next( 'viw_section', content, index );
		if(current_section!==undefined){
			
			var tmpsection = new Array();
			var tmpsectiondata = new Object();
			
			$.each(current_section.shortcode.attrs.named, function(attribute, value) {
				//console.log("attribute ="+attribute+" value = "+value);
				tmpsectiondata[attribute]=value;
			});
			tmpsection["data"]=tmpsectiondata;
			tmpsection["row"]= new Array();
			
			var section_content = current_section.shortcode.content;
			var row_index = 0;
			//  ******* parse row in current section ******* 
			do{
				var current_row = wp.shortcode.next( 'viw_row', section_content, row_index );
				if(current_row!==undefined){
					var tmprow = new Array();
					var tmprowdata =  new Object();
			
					$.each(current_row.shortcode.attrs.named, function(attribute, value) {
						//console.log("attribute ="+attribute+" value = "+value);
						tmprowdata[attribute]=value;
					});
					tmprow["data"]=tmprowdata;
					tmprow["col"]= new Array();
					
					var row_content = current_row.shortcode.content;
					var col_index = 0;
					//  ******* parse col in current row ******* 
					
					do{
						var current_col = wp.shortcode.next( 'viw_col', row_content, col_index );
						//console.log("---------------> current_col = "+current_col);
						
						if(current_col!==undefined){
							var tmpcol = new Array();
							var tmpcoldata =  new Object();
							$.each(current_col.shortcode.attrs.named, function(attribute, value) {
								//console.log("attribute ="+attribute+" value = "+value);
								tmpcoldata[attribute]=value;
							});
							tmpcol["data"]=tmpcoldata;
							tmpcol["widget"]= new Array();
							
							// ******* parse elements in current column ******* 
							column_content = current_col.shortcode.content+'[last_viw_limit v=1]'; //last_dnd_limit is to add dummy last shortcode, to fix WordPress wp.shortcode.next method which has problem when there is only one shortcode in string
							var loop_exit=0;
							do{
								loop_exit++;
								var element_shortcode=column_content.substring(column_content.indexOf("[")+1,Math.min(column_content.indexOf(" ",column_content.indexOf("[")), column_content.indexOf("]",column_content.indexOf("["))));
								if(element_shortcode!==''){
									current_element = wp.shortcode.next( element_shortcode, column_content );
									if(typeof current_element !== 'undefined'){
										//var element_name = dnd_from_WP.ABdevDND_shortcode_names[current_element.shortcode.tag];
										//if(element_name === undefined){
											element_name = current_element.shortcode.tag;
										//}
										
									}
									
									if(element_name!=='last_viw_limit'){
										//console.log("----------------------->>>>> element name = "+element_name);
										var shortcode = current_element.content;
										//console.log("----------------------->>>>> shortcode = "+shortcode);
										var tmpwidgetdata = new Object();
										
										$.each(current_element.shortcode.attrs.named, function(attribute, value) {
											//console.log("attribute ="+attribute+" value = "+value);
											tmpwidgetdata[attribute]=value;
										});
										
										
										var element_content = current_element.shortcode.content;
										if(element_content==undefined){
											element_content='';
										}
										
										var tmpwidget = new Array();
										tmpwidget["type"]= current_element.shortcode.tag.substring(4);
										tmpwidget["content"]= element_content;
										tmpwidget["data"]= new Object();
										tmpwidget["data"]= tmpwidgetdata;
										
										tmpcol["widget"].push(tmpwidget);
										
									}
									
									column_content = column_content.replace(current_element.content, '').trim();
								}
							
							}while(column_content.indexOf("[")>=0 && loop_exit<100);
							
							tmprow["col"].push(tmpcol);
							col_index = current_col.index + 1;
						}
					
					}while(current_col!==undefined);
					
					
					tmpsection["row"].push(tmprow);
					row_index = current_row.index + 1;
				}
				
			}while(current_row!==undefined);
			
			oparsing.push(tmpsection);
			index = current_section.index + 1;
		}
		//console.log("current_section = "+current_section);
		//console.dir(current_section);
	}while(current_section!==undefined);
	
	
	// ******* end parsing sections ******* 
	//console.log("-------------------- oparsing = ");
	//console.dir(oparsing);
	//console.log("-------------------- oparsing = ");
	//console.log("content = ");
	//console.dir(content);
	
	//this.display_no_content();
	
	// init working space
	
	this.init_workingspace(oparsing);
	
	
}

viw_visual_wizard.prototype.init_workingspace=function(oparsing){
    //console.log("init init_workingspace");
	var vwscope = this;
	
	$("#viw_ui-whennocontent").hide();
	
	
	var datatemplate = new Array();
	
	this.refjqtemplate = $("#viw_content_ui").viwtemplate({
        scope: this,
		data: datatemplate,
		datachild:oparsing
    }).data("viwtemplate");
	
	
	
	this.refjqsidebar = $("#viw_sidebar-ui").viwsidebar({
        scope: this,
		scopetemplate:vwscope.refjqtemplate
    }).data("viwsidebar");
   
   //this.$template.creation();
   // this.plug["mosaic"].preBuild();
}


//***************************************
// MODAL PART
//***************************************
viw_visual_wizard.prototype.open_modal=function(myroot,mytype,settings){
	var scope = this;
	var myid = myroot.data("jqid");
	var $parent = myroot;
	var datawidget = settings.data;
	
	datawidget["content"]= viwutils.rawurldecode(datawidget["content"]);
	var o = new Object();
	o["widget"]= new Object();
	o["widget"] = datawidget;
	
	var urlatt = VIWPROP.root_admin + 'shortcode_attributes.php?action=edit&widget_type='+mytype+'&widget_id='+myid ;
	
	$.ajax({
		type: "POST",
		cache: false,
		url: urlatt,
	 
		dataType: 'text',
		data: o,
		success: function (data) {
			// on success, post (preview) returned data in fancybox
			$.fancybox(data, {
			  // fancybox API options
			'orig': $parent,
			'transitionIn':'elastic',
			'transitionOut':'elastic',
			  fitToView: false,
				'height':'100%',
				'width':'100%',
			  autoScale: true,
			  autoDimensions: false,
			  autoSize: true,
			  closeClick: false,
			  openEffect: 'none',
			  closeEffect: 'none',
			  padding: 0, // remove white border
			  'showCloseButton':false
			}); // fancybox
			
			scope.prepare_modal(myroot,mytype);
			
		  } // success
	}); // ajax
		
}


viw_visual_wizard.prototype.prepare_modal=function(myroot,mytype){
	//console.log("viw_visual_wizard prepare_modal");
	
	
	var scope = this;
	this.update_preview(myroot,mytype);
			
	$('#vwi_modal_bt_insert_widget').click(function(e){
		e.preventDefault();
		scope.check_modal();
		$.fancybox.close();
	});	
	
	$('#vwi_modal_bt_close').click(function(e){
		e.preventDefault();
		$.fancybox.close();
	});	
	
	// need to change the method
	$('#id_vwi_ui-modal-content-left').height($('.vwi_ui-modal-container-content').height()-50);
	$('#id_vwi_ui-modal-content-right').height($('.vwi_ui-modal-container-content').height()-50);
	
	$( ".vwi_ui_elementchange" ).change(function() {
		scope.checkcolorneeddarkandlight($( this ));
		scope.update_preview(myroot,mytype);
	});
	
	//$(".needselect2").select2();
	
	$('.colorneeddarkandlight').each( function(i) {
		scope.checkcolorneeddarkandlight ($( this ));
	});
	
}

viw_visual_wizard.prototype.checkcolorneeddarkandlight=function(elem){
	var scope = this;
	if (elem.hasClass( "colorneeddarkandlight" ) ) {
		scope.changecolorneeddarkandlight(elem);
	}
}

viw_visual_wizard.prototype.changecolorneeddarkandlight=function(elem){
	var id = $( elem ).prop( "id" );
	var color = $( elem ).val();
	$( elem ).css ("background-color",color);
	$( "#"+id+"_dark" ).val(tinycolor(color).darken().toString());
	$( "#"+id+"_light" ).val(tinycolor(color).lighten().toString());
}

viw_visual_wizard.prototype.check_modal=function(){
	var oform = $( "#vwi_modal_form_attribute" ).serializeArray();
	// transform array form to object
	var bgcolor="#fff";
	var odata = new Object();
	for (var i=0; i<oform.length; i++){
		var name = oform[i]["name"];
		var val = oform[i]["value"];
		val = viwutils.replacequotetoasc(val);
		if (name=="bgcolor") bgcolor = val;
		if (name == "content") {
			// plugin.update_title(val);
			val = viwutils.rawurlencode(val);
		}
		odata[name]=val;
	}
	
	var widget_id = $( "#vwi_modal_form_attribute #id_widget_id" ).val();
	var objjq = this.refjqtemplate.get_refjq(widget_id);
	objjq.set_data(odata);
	objjq.update_bgcolor_ui();
	//var data = objjq.get_data();
	//var type = data["type"];
	//console.log("type = "+type);
	//console.dir(data);
	var type = objjq.getType();
	//console.log("type = "+type);
	if (type=="col") objjq.update_row_spanmed();

	this.generate_content_from_working_space();
}


// clear current process
viw_visual_wizard.prototype.clearme=function(){
	clearTimeout(this._nIDTimeOut);
}

viw_visual_wizard.prototype.update_preview=function(myroot,widget_type){
	this.clearme();
	this.$preview_myroot = myroot;
	this.spreview_widget_type = widget_type;
	
	//this.update_preview2();
	var scope = this;
	this._nIDTimeOut = setTimeout(function(){
		scope.update_preview2();
	}, 500);
}
	
viw_visual_wizard.prototype.update_preview2=function(){	
	myroot= this.$preview_myroot
	widget_type = this.spreview_widget_type;


	var widget_id = myroot.data("jqid");
	var oform = $( "#vwi_modal_form_attribute" ).serializeArray();
	// transform array form to object
	var odata = new Object();
	for (var i=0; i<oform.length; i++){
		var name = oform[i]["name"];
		var val = oform[i]["value"];
		val = viwutils.replacequotetoasc(val);
		odata[name]=val;
	}
	var o = new Object();
	o["widget"]= new Object();
	o["widget"] = odata;
	
	var urlprev = VIWPROP.root_admin + 'modal_preview.php?action=edit&widget_type='+widget_type+'&widget_id='+widget_id+'&random='+viwutils.getuniqueID();
	
	$.ajax({
		type: "POST",
		cache: false,
		url: urlprev, 
		dataType: 'text',
		data: o,
		success: function (data) {
			$( "#id_vwi_ui-modal-content-right" ).html(data);
		  } // success
	}); // ajax
}

viw_visual_wizard.prototype.update_bgcolor_ui=function(el, bgcolor){	
	// update the color of the backgroud
	el.css("background-color",bgcolor);
}







// active checkbox
/*
viw_visual_wizard.prototype.active_checkbox=function(s,s2){
	
	// switch button for wall activation
	$(s).switchButton({
  		on_label: 'yes',
  		off_label: 'no',
		show_labels: false
	});
	
	
	$(s).change(function() {		
		var val = $(this).is(":checked");
		var wg_id = $(this).data('media_id');
		console.log("media id ="+wg_id);
		if (val==true) {
			$(s2+wg_id).val(1);
		}else{
			$(s2+wg_id).val(0);
		}		
	});
}
*/
viw_visual_wizard.prototype.load_font=function(){	
	// 
	viwfont.loadIcons(VIWPROP.root_plugins+"assets/fontawesome/font-awesome.min.css");
}


/*----------------------------------------------------*/
/*	LOAD FONT
/*----------------------------------------------------*/

/*----------------------------------------------------*/
/*	INSTANCE OBJECT
/*----------------------------------------------------*/

var viw_visual_wizard = new viw_visual_wizard();


(function($) {
	$(document).ready(function(){
	
		viw_visual_wizard.init();
		
});

})(this.jQuery);
