<?php

// http://coffeerings.posterous.com/php-simplexml-and-cdata
class SimpleXMLExtended extends SimpleXMLElement {
	public function addCData($cdata_text) {
		$node = dom_import_simplexml($this);
		$no   = $node->ownerDocument;
		$node->appendChild($no->createCDATASection($cdata_text));
	}

	public function addChildcdata($element_name, $cdata) {
		$this->$element_name = NULL;
		$this->$element_name->addCData($cdata);
	}
}


/*
http://secretsitebox.fr/themesspx/dev/visualwizard/plugins/spxvisualwizard/admin/record_article.php?page_id=0002&page_type=article
http://stackoverflow.com/questions/6260224/how-to-write-cdata-using-simplexmlelement
*/
require( 'ajax.php' );

$page_id = (isset($_GET['page_id'])) ? $_GET['page_id'] : '';
$page_type = (isset($_GET['page_type'])) ? $_GET['page_type'] : '';
# post var widget jquery
$input = file_get_contents("php://input");
parse_str($input, $post_var);
// lig 177 article.php
if(($aFile = $plxMotor->plxGlob_arts->query('/^'.$page_id.'.(.+).xml$/')) == false) { # Article inexistant
	return false;
}
$filename = PLX_ROOT.$plxMotor->aConf['racine_articles'].$aFile['0'];
$articlexml = new SimpleXMLExtended(file_get_contents($filename));
//$articlexml->content = '<![CDATA['.'toto'.']]>';
//$articlexml->addChildcdata($articlexml->content, 'Site Title');
$articlexml->content = NULL; // VERY IMPORTANT! We need a node where to append
$articlexml->content->addCData($post_var["content"]);
$xml = $articlexml->asXML();

# On écrit le fichier
//$filename2 = PLX_ROOT.$plxMotor->aConf['racine_articles']."test.xml";
if(plxUtils::write($xml,$filename))
	echo true;#bizarre
else
echo false;#bizarre

?>