<?php

// http://coffeerings.posterous.com/php-simplexml-and-cdata
class SimpleXMLExtended extends SimpleXMLElement {
	public function addCData($cdata_text) {
		$node = dom_import_simplexml($this);
		$no   = $node->ownerDocument;
		$node->appendChild($no->createCDATASection($cdata_text));
	}

	public function addChildcdata($element_name, $cdata) {
		$this->$element_name = NULL;
		$this->$element_name->addCData($cdata);
	}
}

/*
http://secretsitebox.fr/themesspx/dev/visualwizard/plugins/spxvisualwizard/admin/record_article.php?page_id=0002&page_type=article
http://stackoverflow.com/questions/6260224/how-to-write-cdata-using-simplexmlelement
*/
require( 'ajax.php' );

$page_id = (isset($_GET['page_id'])) ? $_GET['page_id'] : '';
$page_type = (isset($_GET['page_type'])) ? $_GET['page_type'] : '';
# post var widget jquery
$input = file_get_contents("php://input");
parse_str($input, $post_var);

// path('XMLFILE_CATEGORIES') -> PLX_ROOT.PLX_CONFIG_PATH.'categories.xml'
$filename = PLX_ROOT.PLX_CONFIG_PATH.'categories.xml';

/* just for test plugins/spxvisualwizard/admin/record_categorie.php?page_id=001&page_type=categorie */
// $page_id ='002';
// $filename = PLX_ROOT.PLX_CONFIG_PATH.'categoriestest.xml';
// $post_var["content"] = "just a test jéjé 5";


$categoriesxml = new SimpleXMLExtended(file_get_contents($filename));
// find node with $page_id <categorie number="001" ...>
// <description> ...

$path = '//categorie[@number="'.$page_id.'"]';
foreach ($categoriesxml->xpath($path) as $catxml) {
	$catxml->description = NULL; // VERY IMPORTANT! We need a node where to append
	$catxml->description->addCData($post_var["content"]);
	$xml = $categoriesxml->asXML();
	if(plxUtils::write($xml,$filename))
		echo true;
	else
		echo false ;
	exit;
}
echo false ;
// http://stackoverflow.com/questions/16054386/access-all-children-of-a-certain-node-with-simplexml-and-php
?>