/* VIW ACCS
------------------------------ */
$.fn.viw_accs_fx = function() {
	// http://uniondesign.ca/simple-accordion-without-jquery-ui/
	
	return this.each(function() {
		
		var el = $(this),
		accs_nav_a = el.find('.viw_acc-group-title');
		
		$('.viw_accs-container .viw_acc-group',el).first().addClass('viw_acc-active'); // Default*/
		
		accs_nav_a.on('click', function(event) {
			event.preventDefault();
			// Expand or collapse this panel
			// Hide the other panels
			var scope = $('.viw_acc-group-content',el);
			scope.not($(this).next()).slideUp('fast');
			$(this).next().slideToggle('fast', function() {
				//console.log("done !!!");
				scope.each(function() {
					if ($(this).css('display') == 'block'){
						$(this).parent().addClass('viw_acc-active');
					}else{
						$(this).parent().removeClass('viw_acc-active');
					}
				});
				
			});	
			
		});
		
		
	});
}

/* VIW TABS
------------------------------ */
$.fn.viw_tabs_fx = function() {

  return this.each(function() {
	 var el = $(this),
	tabs_nav_a = el.find('.viw_tabs-nav a');
	
	//console.dir(tabs_nav_a);
	tabs_nav_a.on('click', function(event) {
		event.preventDefault();
		$('.viw_tab-active',el).removeClass('viw_tab-active');
		$(this).parent().addClass('viw_tab-active');
		$('.viw_tabs-stage .viw_tab-content', el).hide();
		
		var url = $(this).attr('href');
		var test = url.indexOf("#");
		if (test!=-1){
			var tmp = url.split('#'); 
			var arr = "#"+tmp[1];
			$(arr).show();
		}
    });
	
	$('.viw_tabs-nav a:first', el).trigger('click'); // Default*/
  });

}


/* VARIOUS FUNCTION
------------------------------ */
// call this function for prewiew
function init_viw_ui_preview() {
	
	//$('.viw_ui-modal-preview-container .viw-tabs-inner').responsiveTabs();
	$('.viw_tabs').viw_tabs_fx();
	//$('.viw_ui-modal-preview-container .viw_accs').viw_accs_fx();
	$('.viw_ui-modal-preview-block .viw_accs').viw_accs_fx();
}

function img_circle() {
	$('.vwi_image-shapeperfectcircle').each(function() {
		$w = $(this).width();
		$(this).height($w);
	});
}

function viw_handleResize() {
	var h = $(window).height();
	
    $('.vwi_section.vwi_section-fullheight').css({'min-height':h+'px'});
	$('.vwi_section.vwi_section-fullheight-video').css({'height':h+'px'});
	$('.vwi_section.vwi_section-fullheight-video .vwi_section-container').css({'height':h+'px'});
	
	// same size of the section
	// for each
	//var hsection = $('.vwi_section').height();
	$('.vwi_section').each(function( index ) {
		var hsection = $(this).height();
		$('.vwi_section-particule-item', this).css({'height':hsection+'px'});
		$('.vwi_section-particule-item .bubble-wrap', this).css({'height':hsection+'px'});
	});
	
	// segmenter background
	$('.vwi_section-container-segmenter-content').each(function( index ) {
		if ($(this).parent().hasClass( "vwi_section-fullheight" )){
			var hsection = $(this).parent().height();
			$(this).css({'height':hsection+'px'});
			$(this).next().css({'height':hsection+'px'});
		}else{
			var hsection = $(this).height();
			$(this).next().css({'height':hsection+'px'});
		}
		
	});
}

function scrollToAnchor(aid){
	
    var aTag = $(aid);
    $('html,body').animate({scrollTop: aTag.offset().top},1000);
}


$(function(){
	
	
    viw_handleResize();

    $(window).resize(function(){
        viw_handleResize();
    });
	
	$(".vwi_button").click(function(e) {
		
		var url = $(this).attr('href');
		var test = url.indexOf("#");
		
		var tmp = url.split('#'); 
		var arr = "#"+tmp[1];
	
		if (test!=-1){
			scrollToAnchor(arr);
			e.preventDefault();
		}
	});
	
	// $('.viw-tabs-inner').responsiveTabs();
	
	
	
	/* WIDGET CONTACT
	------------------------------ */
	//$('.viw_simpleform').viw_simpleform_fx();
	/* WIDGET TABS
	------------------------------ */
	$('.viw_tabs').viw_tabs_fx();
	/* WIDGET AACORDION
	------------------------------ */
	$('.viw_accs').viw_accs_fx();
});
// youtube fs : https://codepen.io/ccrch/pen/GgPLVW