// root is jquery object root.show()
// plugin.method()
// setting : setting.value
// variable : variable
// idd = instance drag & drop with a string text with separator ##

(function($) {
	//----------------------------------------------------------plugin class
    $.viwidd = function(target, options) {
	//--------------------------------------------------------variable
		var plugin = this;
		
		var root=$(target);
		
		var interval=0;
		
		var _clScopeTarget ;
		

	//--------------------------------------------------------settings
		var settings = {
			scope: null,
			data: [],
			field: '',

		};   
	
	//--------------------------------------------------------constructor
		plugin.init = function(options) {
			settings= $.extend(settings, options); 
			plugin.creation();
			// plugin.initbuttons();
			plugin.update();
			//plugin.addwysiwyg('.needtrumbowyg-list');
			plugin.eventbuttonchange();
		}
	//-------------------------------------------------------public function
		plugin.creation = function() {
			var s = settings.field;
			var content = $(".vwi_ui-modal-container-content "+s).val();
			var a = viwutils.explode("##",content);
			
			var out =  '<div class="viw_ui-idd-container-controls-new" ><a type="button" class="viw_ui-control-idd viw_ui-control-idd-new" data-subaction="add" >&nbsp;<i class="fa fa-plus" aria-hidden="true"></i>&nbsp;</a></div>';
			out += '<div class="viw_clearfix" ></div>';
			out += '<div class="viw_ui-idd-sortable" >';
			for (var i=0; i<a.length; i++){
				out += plugin.getDefaultIddHtml(a[i]);
			}
			out += '</div>';
			
			root.html(out);
			
		}
		
		//***************************************
		// PUBLIC
		//***************************************
		
		plugin.setScopeTarget= function(scope) {
			_clScopeTarget = scope;
		}
	
		plugin.killer= function() {
			// plugin.stopAnim();
			root.empty();
		}
		
		plugin.update= function() {
			var s= '';
			$( ".viw_ui-idd-container .idd-content1", root ).each(function( index ) {
				console.log( index + ": " + $( this ).val() );
				s += $( this ).val()+"##";
			});
			s = s.substring (0, s.length-2);
			
			var field = $(".vwi_ui-modal-container-content "+settings.field);
			$(field).val(s);
			$(field).change();
			
			$( ".viw_ui-idd-sortable", root ).sortable({
				stop: function(){
					plugin.update();
				},
			  handle: ".viw_ui-idd-container-controls", 
			  revert: true,
				tolerance: "pointer",
				placeholder: "viw_ui-idd-container_placeholder",
				forcePlaceholderSize: true,
			});
			
			plugin.initbuttons();
			plugin.eventbuttonchange();
		}
		
		plugin.initbuttons= function() {
			var scope = this;
			var scoperoot = root;
			// off() Remove an event handler.
			$('.viw_ui-control-idd-delete', root).off().click(function(e){
				e.preventDefault(); 
				$(this).parent().parent().remove();
				scope.update();
			});	
			$('.viw_ui-control-idd-duplicate', root).off().click(function(e){
				e.preventDefault(); 
				var container = $(this).parent().parent();
				scope.clone(container);
			});
			
			$('.viw_ui-control-idd-new', root).off().click(function(e){
				e.preventDefault(); 
				scope.newidd();
			});
			
			
			$('.viw_ui-control-idd-toggle', root).off().click(function(e){
				e.preventDefault(); 
				console.log("click")
				if ($(this).hasClass("viw_ui-collapsed-idd")){
					$(this).removeClass("viw_ui-collapsed-idd");
					
					$(this).find("i").removeClass("fa-chevron-right").addClass("fa-chevron-down");  					
					$('.idd-content1', $(this).parent().parent()).show();
				} else{
					$(this).addClass("viw_ui-collapsed-idd");
					$(this).find("i").removeClass("fa-chevron-down").addClass("fa-chevron-right"); 
					$('.idd-content1', $(this).parent().parent()).hide();
				
				}
				// 
			});	
			
			
				

		}

		//***************************************
		// PRIVATE
		//***************************************
		plugin.clone = function(s) {
			s.clone().appendTo(".viw_ui-idd-sortable", root);
			plugin.update();
		}
		plugin.newidd = function(s) {
			var s= plugin.getDefaultIddHtml('list item');
			$(".viw_ui-idd-sortable", root).append(s);
			plugin.update();
		}
		
		plugin.getDefaultIddHtml = function(s) {
			out = '<div class="viw_ui-idd-container viw_clearfix">';
				out += '<div class="viw_ui-idd-container-controls" >';
						
					out += '<a type="button" class="viw_ui-control-idd viw_ui-control-idd-move" data-subaction="del" >&nbsp;<i class="fa fa-arrows" aria-hidden="true"></i>&nbsp;</a>';
					out += '<a type="button" class="viw_ui-control-idd viw_ui-control-idd-toggle" data-subaction="del" >&nbsp;<i class="fa fa-chevron-down" aria-hidden="true"></i>&nbsp;</a>';
					out += '<a type="button" class="viw_ui-control-idd viw_ui-control-idd-delete" data-subaction="del" >&nbsp;<i class="fa fa-times-circle"></i>&nbsp;</a>';
					out += '<a type="button" class="viw_ui-control-idd viw_ui-control-idd-duplicate" data-subaction="del" >&nbsp;<i class="fa fa-files-o" aria-hidden="true"></i>&nbsp;</a>';
					out += '<div class="viw_clearfix" ></div>';
				out += '</div>';
			
				out += '<textarea class="idd-content1 needtrumbowyg-list" style="width:100% !important;resize: none;"  >'+s+'</textarea>';
			out += '</div>';
			
			return out;
		}
		
		plugin.eventbuttonchange = function() {
			var scope = plugin;
			$( ".needtrumbowyg-list", root ).off().change(function() {
				scope.update();
			});
		}
	
		
		plugin.addwysiwyg = function(s) {
			// https://alex-d.github.io/Trumbowyg/
			
			$(s,root).trumbowyg('destroy');
			$(s,root).trumbowyg(
			{
				btns: [['viewHTML'],['bold', 'italic'], ['link']],
				autogrow: false
			})
			.on('tbwfocus', function(){ console.log('Focus!'); }) // Listen for `tbwfocus` event
			.on('tbwchange', function(){ 
				console.log('Change!'); }); // Listen for `tbwfocus` event
				//scope.update();
		}
		
		plugin.tracer = function(s) {
			//console.log ("dp-signage-engine: "+s);
		}
		plugin.tracer2 = function(o) {
			//console.dir (o);
		}
	  
		//-----------------------------------------------------------initialisation 
		plugin.init(options);
	
	}	
	//-------------------------------------------------------------plugin inclusion
    $.fn.viwidd = function(options) {
        return this.each(function() {
            if ($(this).data('viwidd') == undefined  ) {
                var plugin = new $.viwidd(this, options);
                $(this).data('viwidd', plugin);
            }
        });
    }
	
})(jQuery);