// root is jquery object root.show()
// plugin.method()
// setting : setting.value
// variable : variable

(function($) {
	//----------------------------------------------------------plugin class
    $.viwsidebar = function(target, options) {
	//--------------------------------------------------------variable
		var plugin = this;
		
		var root=$(target);
		
		var interval=0;
		
		var _clScopeTarget ;
		

	//--------------------------------------------------------settings
		var settings = {
			scopetemplate:null
		};   
	
	//--------------------------------------------------------constructor
		plugin.init = function(options) {
			settings= $.extend(settings, options); 
			plugin.creation();
			plugin.active_savepage_button();
			plugin.active_navbar_button();
			plugin.active_displaymode_button();
			
			plugin.get_page_widget();
			plugin.get_page_mywidget();
			plugin.get_page_template();
			plugin.get_page_config();
			
			// click on widget
			$(".viw_navbar-nav .viw_icon-btn.viw_widget-button", root).click();
			
			//console.log("sidebar:"+settings.scopetemplate);
		}
	//-------------------------------------------------------public function
		plugin.creation = function() {
			
			/* perfect-scrollbar */
			var s = '<div class="viw_sidebar-ui_header" >';
				
				s+='<a id="viw_ui_savepage-button" class="viw-ui_button" title="'+VIWPROP.loc.L_SAVE_PAGE_DESC+'" >'+VIWPROP.loc.L_SAVE_PAGE+' ';
					s+='<i class="fa fa-spinner fa-spin fa-fw"></i>';
				s+='</a>';
				
				// s+='<ul class="viw_sidebar-ui_header_navbar-nav" ><li><a class="viw_icon-btn viw_ui_wireframe-button viw_navbar-border-right" id="id_viw_ui_displaymode_bt"  title="Change display mode"></a></li></ul>';
				
				
				s+='<ul class="viw_sidebar-ui_header_navbar-nav" ><li><a href="javascript:void(0);" class="viw_icon-btn viw_ui_wireframe-button viw_navbar-border-right" id="viw_ui_display-mode-button"  title="Change display mode"></a></li></ul>';
			s += '</div>';
			
			
			s += '<div class="viw_clearfix" ></div>';
			s += '<div class="viw_sidebar-ui_navbar" >';
			
				s += '<ul class="viw_navbar-nav">';
					
						s += '<li><a href="javascript:void(0);" data-menu="widget" class="viw_icon-btn viw_widget-button viw_navbar-border-right" id="viw_templates-editor-button" title="'+VIWPROP.loc.L_WIDGETS+'"></a></li>';
						
						//s += '<li><a href="javascript:void(0);" data-menu="mywidget" class="viw_icon-btn viw_mywidget-button viw_navbar-border-right disable" id="viw_templates-editor-button" title="'+VIWPROP.loc.L_MY_WIDGETS+'"></a></li>';
						
						//s += '<li><a href="javascript:void(0);" data-menu="template" class="viw_icon-btn viw_templates-button viw_navbar-border-right disable " id="viw_templates-editor-button" title="'+VIWPROP.loc.L_TEMPLATES+'"></a></li>';
						
						s += '<li><a href="javascript:void(0);" data-menu="config" class="viw_icon-btn viw_reglage-button viw_navbar-border-right disable" id="viw_templates-editor-button" title="'+VIWPROP.loc.L_PREFERENCES+'"></a></li>';
						
						
					
				s += '</ul>';
			
			s += '</div>';
			
			s += '<div class="viw_sidebar-ui_content" >';
				s +=  '<div id="id_viw_sidebar-ui_content-page-widget" class="viw_sidebar-ui_content-page " >...</div>';
				s +=  '<div id="id_viw_sidebar-ui_content-page-mywidget" class="viw_sidebar-ui_content-page" >...</div>';
				s +=  '<div id="id_viw_sidebar-ui_content-page-template" class="viw_sidebar-ui_content-page" >...</div>';
				s +=  '<div id="id_viw_sidebar-ui_content-page-config" class="viw_sidebar-ui_content-page" >...</div>';
			s += '</div>';
			s += '<div class="viw_sidebar-ui_footer" >';
			//s +=  'footer';
			s += '</div>';
			root.html(s);
			
			$(".viw_sidebar-ui_content").perfectScrollbar();
			//$(".viw_inside_ui").perfectScrollbar();
			
			$("#viw_visual_wizard_ui").perfectScrollbar();
		}
		
		
		//***************************************
		// PUBLIC
		//***************************************
		
		plugin.setScopeTarget= function(scope) {
			_clScopeTarget = scope;
		}
	
		
		plugin.killer= function() {
			// plugin.stopAnim();
			root.empty();
		}
		
		//***************************************
		// PRIVATE
		//***************************************
		plugin.active_navbar_button = function() {
			var scope= this;
			$(".viw_navbar-nav .viw_icon-btn", root).click(function(e){
				e.preventDefault();
				var menu = $(this).data("menu");
				$(".viw_sidebar-ui_content-page", root).hide();
				
				
				$(".viw_navbar-nav .viw_icon-btn", root).addClass( "disable" );
				$(this).removeClass("disable");
				
				$("#id_viw_sidebar-ui_content-page-"+menu, root).show();
				
				$(".viw_sidebar-ui_content").scrollTop(0);
				$(".viw_sidebar-ui_content").perfectScrollbar('update');
			});
		}
		
		plugin.active_savepage_button = function() {
			$("#viw_ui_savepage-button .fa-spinner", root).hide();
			var scope= this;
			$("#viw_ui_savepage-button", root).click(function(e){
				e.preventDefault();
				viw_visual_wizard.savepage($(this), $("#viw_ui_savepage-button .fa-spinner", root));
			});
		}
		
		plugin.active_displaymode_button = function() {
			$("#viw_ui_display-mode-button",root).click(function(e){
				e.preventDefault();
				//console.log("clic !!!");
				viw_visual_wizard.change_display_mode($(this));
				$("#viw_visual_wizard_ui").scrollTop(0);
				$("#viw_visual_wizard_ui").perfectScrollbar('update');
			});
		}
		
		plugin.get_page_widget = function() {
			var urlatt = VIWPROP.root_admin + 'widget_selector.php';
		
			$.ajax({
					type: "GET",
					cache: false,
					url: urlatt, // preview.php
				  //data: $("#postp").serializeArray(), // all form fields
					dataType: 'text',
					success: function (data) {
						
						$(".viw_sidebar-ui_content #id_viw_sidebar-ui_content-page-widget", root).html(data);
						plugin.do_drag_widget();
						plugin.do_drag_widgetsystem();
						
						
					  } // success
			}); // ajax
					
		}
		
		/* http://stackoverflow.com/questions/19732011/jquery-ui-droppable-and-sortable-dropping-in-the-correct-sort-location */
		/* http://bseth99.github.io/projects/jquery-ui/8-draggable-sortable-droppable.html */
		plugin.do_drag_widget = function() {
			// acceptation par do drag widget du template
			// if (ui.item.hasClass( "viw_sidebar-ui_widget-container" )) {
					// plugin.create_widget_from_sidebar(ui);
			// }
			$( ".viw_sidebar-ui_widget-container", root ).draggable({
				helper: "clone",
				connectToSortable: ".viw_ui-col-container",
				appendTo: "body",
				zIndex: 99999,
				revert: "invalid",
				cursorAt: { left: 5 },
				scroll:false,
				drag: function(e, ui)
				 {
					
				 },
				start: function (event, ui) {
					$(this).hide();
				},
				stop: function( event, ui ) {
					$(this).show();
				}
			}).disableSelection();
		}
		
		plugin.do_drag_widgetsystem = function() {
			
			// acceptation par do drag du section dans la template.js
			$( ".viw_sidebar-ui_widgetsystem-container-section", root ).draggable({
				helper: "clone",
				connectToSortable: ".viw_content_ui",
				appendTo: "body",
				zIndex: 99999,
				revert: "invalid",
				cursorAt: { left: 5 },
				drag: function(e, ui)
				 {
				 
				 },
				stop: function( event, ui ) {
					
				}
			}).disableSelection();
			
			// acceptation par do drag du raw dans la section.js
			/*update: function(e, ui){
				if (ui.item.hasClass( "viw_sidebar-ui_widgetsystem-container-row" )) {
					plugin.create_row_from_sidebar(ui);
				}
			},*/
			$( ".viw_sidebar-ui_widgetsystem-container-row", root ).draggable({
			
				helper: "clone",
				connectToSortable: ".viw_ui-section-container",
				appendTo: "body",
				zIndex: 99999,
				revert: "invalid",
				cursorAt: { left: 5 },
				
				drag: function(e, ui)
				 {
					
				 },
				start: function (event, ui) {
					//$(this).hide();
				},
				stop: function( event, ui ) {
					//$(this).show();
				}
			}).disableSelection();
			
			
		}
		
		plugin.get_page_mywidget = function() {
			var urlatt = VIWPROP.root_admin + 'mywidget_selector.php';
		
			$.ajax({
					type: "GET",
					cache: false,
					url: urlatt,
					dataType: 'text',
					success: function (data) {
						$(".viw_sidebar-ui_content #id_viw_sidebar-ui_content-page-mywidget", root).html(data);
					  } // success
			}); // ajax
		}
		
		plugin.get_page_template = function() {
			var urlatt = VIWPROP.root_admin + 'template_selector.php';
		
			$.ajax({
					type: "GET",
					cache: false,
					url: urlatt,
					dataType: 'text',
					success: function (data) {
						$(".viw_sidebar-ui_content #id_viw_sidebar-ui_content-page-template", root).html(data);
					  } // success
			}); // ajax
		}
		
		plugin.get_page_config = function() {
			var urlatt = VIWPROP.root_admin + 'config_selector.php';
		
			$.ajax({
					type: "GET",
					cache: false,
					url: urlatt,
					dataType: 'text',
					success: function (data) {
						$(".viw_sidebar-ui_content #id_viw_sidebar-ui_content-page-config", root).html(data);
						plugin.init_page_config();
					  } // success
			}); // ajax
		}
		
		plugin.init_page_config = function() {
			// 
			//console.log("init config !!!!");
			$( "#id_viw_sidebar-ui_tuning .viw_sidebar-ui_panel-item", root ).click(function(e){
				e.preventDefault();
				var link = $(this).data("link");
				//console.log("clic !!!"+link);
				switch(link) {
					case "colors":
						// open a popup up to set colors
						break;
					case "fonts":
						// open a popup up to set fonts
						break;
					case "tuning":
						window.open(VIWPROP.root_config);
						break;
					case "currentpage":
						// open a popup up to confirm clear page or other action...
						break;
					case "about":
						window.open(VIWPROP.loc.L_REF_SITE_URL);
						break;
					
						
				}
				
			});
		}
		
		
		
		
		
		
		
		/*
		plugin.getHelper = function(event, ui) {
			var helper = $(ui).clone();
			helper.addClass("ui-draggable-helper");
			return helper;
		}
		*/
		
		plugin.update_workingspace = function() {
			settings.scopetemplate.update_width();
			viw_visual_wizard.generate_content_from_working_space();
		}
		
		plugin.tracer = function(s) {
			//console.log ("dp-signage-engine: "+s);
		}
		plugin.tracer2 = function(o) {
			//console.dir (o);
		}
	  
		//-----------------------------------------------------------initialisation 
		plugin.init(options);
	
	}	
	//-------------------------------------------------------------plugin inclusion
    $.fn.viwsidebar = function(options) {
        return this.each(function() {
            if ($(this).data('viwsidebar') == undefined  ) {
                var plugin = new $.viwsidebar(this, options);
                $(this).data('viwsidebar', plugin);
            }
        });
    }
	
})(jQuery);