<?php
/**
 * Classe plxForm
 *
 * @package PLX
 * @author	Evrard J.
 **/
class spxdisplayForm {

	public static $acolorConfig = array();
	public static $aLang = array();

	public static function setColorConfig($a) {
		self::$acolorConfig = $a;
	}

	public static function setLang($a) {
		self::$aLang = $a;
	}

	public static function getLang($key='') {
		if(isset(self::$aLang[$key]))
			return self::$aLang[$key];
		else
			return $key;
	}

	// "base"=>       "#e51c23",
	//'#e51c23' =>  'base,
	//'#e51c23' => 'background-color:#e51c23;',
	public static function getColorConfigformName($bdefault=true) {
		$out = array();
		foreach(self::$acolorConfig as $palettes=>$palette) {
			if (!($bdefault==false && $palettes=="default")){
				$out[$palettes] = array();
				foreach($palette as $name=>$color) {
					if (!($bdefault=false && $color=="")){
						$out[$palettes][$color]=$palettes." ".$name." - ".$color;
					}
				}
			}
		}
		return $out;
	}

	public static function getColorConfigformBackground($bdefault=true) {
		$out = array();
		foreach(self::$acolorConfig as $palettes=>$palette) {
			if (!($bdefault==false && $palettes=="default")){
				$out[$palettes] = array();
				foreach($palette as $name=>$color) {
					$out[$palettes][$color]='background-color:'.$color.';';
				}
			}
		}
		return $out;
	}

	public static function getHTMLfield($params, $type="") {
		// array(id, name, class, onclick, disabled, style, tabindex, class, size, value, maxlength, placeholder, extra)
		$params["name"]=$params["param_name"];
		//$params["id"]=$params["param_name"];
		if(!isset($params["class"])) $params["class"] = '';
		$params["class"].=" vwi_ui_elementchange";

		switch ($type) {

		case "image":

			# image
			$plxAdmin =  plxAdmin::getInstance();
			$basepath_image = isset($plxAdmin->aConf['medias']) ? $plxAdmin->aConf['medias'] : $plxAdmin->aConf['images'];

			//$params["value"] = stripslashes ($params["value"]);

			$value = $params["value"];
			$id = "id_".$params["name"];
			//$id =  uniqid();
			//$params["id"]=$id;
			$s = spxForm::text($params);



			$replace = false;
			$fallback = "myfallback";
			//
			$s.='<a title="'.self::getLang('L_CHOOSE_AN_IMAGE').'" id="toggler" href="javascript:void(0)" onclick=\'mediasManager.openPopup("'.$id.'","'.$replace.'","'.$fallback.'")\' style="outline:none">';

			$image_path="../../".$basepath_image.$value;


			if ($value!="") {
				$s.='<img id="img_'.$id.'" height="50" src="'.$image_path.'" class="thumb"></a>';
			}else{
				$image_path='../../plugins/spxvisualwizard/admin/images/noimage.png';
				$s.='<img id="img_'.$id.'" height="50" src="'.$image_path.'" class="thumb"></a>';
			}

			$s.="\n\t".'<script>';
			$s.="\n\t".'$(document).ready(function() {';
			$s.="\n\t".'$("#'.$id.'").focus( function() {';
				$s.="\n\t".'var val = $(this).val();';
				$s.="\n\t".'$(this).val(val.replace("'.$basepath_image.'", ""));';

  				$s.="\n\t".'console.log ("ca marche  !!");';
				// check input ($(this).val()) for validity here
				$s.="\n\t".' var im= "../../'.$basepath_image.'"+$(this).val();';
				$s.="\n\t".'$("#img_'.$id.'").attr("src",im);';
				$s.='$( ".vwi_ui_elementchange" ).change();';
			$s.=	"\n\t".'});';
			$s.=	"\n\t".'});';
			$s.="\n\t".'</script>';


			return $s;


		break;



		case "imagenojs":
			$id =  uniqid();
			$id_img =  'img_'.$id;
			$value = stripslashes ($params["value"]);
			$plxAdmin =  plxAdmin::getInstance();
			$basepath_image = isset($plxAdmin->aConf['medias']) ? $plxAdmin->aConf['medias'] : $plxAdmin->aConf['images'];
			$image_path="../../".$basepath_image.$value;

			//$params["id"]=$id;
			$s = spxForm::text($params);

			$replace = false;
			$fallback = "myfallback";
			//
			$s.='<a title="'.self::getLang('L_CHOOSE_AN_IMAGE').'" id="toggler" href="javascript:void(0)" onclick=\'mediasManager.openPopup("'.$id.'","'.$replace.'","'.$fallback.'")\' style="outline:none">';

			if ($value!="") {
				$s.='<img id="'.$id_img.'" src="'.$image_path.'" class="thumb"></a>';
			}else{
				$image_path='../../plugins/spxvisualwizard/admin/images/noimage.png';
				$s.='<img id="'.$id_img.'" src="'.$image_path.'" class="thumb"></a>';
			}

			return $s;
		break;
		case "icon":
			$iconpicker_id = "id_icon-picker-".uniqid();
			$s='
			<div class="icon-picker" id="'.$iconpicker_id.'" data-pickerid="fa" data-iconsets=\'{"fa":"'.self::getLang('L_CHOOSE_FONTAWESOME').'"}\'>
				';
				$params["value"] = stripslashes ($params["value"]);
				$s.= spxForm::hidden($params);
			$s.=	'
			</div>


			<script type="text/javascript">
						(function($){

							$(document).ready(function(){



								$("#'.$iconpicker_id.'").qlIconPicker({
									"save": "class",
									"mode":"dialog"

								});


							});

						})(jQuery);
					</script>

			';


			return $s;


		break;
		case "textarea":

			// $params["value"] = rawurldecode($params["value"]);
			// http://php.net/manual/fr/function.rawurlencode.php
			// http://php.net/manual/fr/function.rawurldecode.php

			// http://locutus.io/php/ PHP extensions in JavaScript
			// http://locutus.io/php/url/rawurldecode/
			// http://locutus.io/php/url/rawurlencode/

			$params["value"] = stripslashes ($params["value"]);


			return spxForm::textarea($params);
		break;

		case "tinymce":
			$params["id"] = "id_texthtml-".uniqid();
			$params["value"] = stripslashes ($params["value"]);
			$s =  spxForm::textarea($params);
			// <script src="https://cloud.tinymce.com/stable/tinymce.min.js"></script>
			// in header wizard <script src='https://cloud.tinymce.com/stable/tinymce.min.js?apiKey=ybr8amj8yjdidksqudpu92ohoufbqrazbthpait932k7q1gq'></script>
			$s.='

			<script>
				(function($){
					$(document).ready(function(){

						tinymce.init({
							  selector: "#'.$params["id"].'" ,


							  height: 500,
							  menubar: false,
							  plugins: [
								"advlist autolink lists link image charmap print preview anchor",
								"searchreplace visualblocks code fullscreen",
								"insertdatetime media table contextmenu paste code"
							  ],
							  toolbar: "undo redo | insert | styleselect | bold italic | alignleft aligncenter alignright alignjustify | bullist numlist outdent indent | link image",
							  content_css: "//www.tinymce.com/css/codepen.min.css"




					});



						//$("#'.$params["id"].'").tinymce();
						/*
						$("#'.$params["id"].'").tinymce({

							setup : function(ed) {
							ed.onChange.add(function(ed, l) {
							  console.log ("tiny change !!!!");
							  $( ".vwi_ui_elementchange" ).change();
							});
							},

							plugins: "textcolor",
							toolbar: "forecolor backcolor",
							textcolor_map: [
								"000000", "Black",
								"993300", "Burnt orange",
								"333300", "Dark olive",
							],



						});
						*/






					});
				})(jQuery);


			</script>
			';
			return $s;


			/*
			tinymce.init({

						selector:"#'.$params["id"].'" ,

						setup : function(ed) {
							ed.onChange.add(function(ed, l) {
							  console.log ("tiny change !!!!");
							  $( ".vwi_ui_elementchange" ).change();
							});
						},

						plugins: "textcolor",
						toolbar: "forecolor backcolor",
						textcolor_map: [
							"000000", "Black",
							"993300", "Burnt orange",
							"333300", "Dark olive",
						],

						});
			*/

		break;
		case "texthtml":
			$params["id"] = "id_texthtml-".uniqid();
			$params["value"] = stripslashes ($params["value"]);
			$s =  spxForm::textarea($params);
			$s.='
			<script type="text/javascript">
				(function($){
					$(document).ready(function(){
						$("#'.$params["id"].'")
						.trumbowyg(
								{
									btns: [
										["viewHTML"],
										["undo", "redo"],
										["foreColor", "backColor"],
										["formatting"],
										"btnGrp-design",
										["link"],
										["insertImage"],

										"btnGrp-justify",

										"btnGrp-lists",





										["preformatted"],
										["horizontalRule"],
										["fullscreen"]




									],
									autogrow: true
								}

						) // Build Trumbowyg on the #editor element
						//.on("tbwfocus", function(){ console.log("Focus!"); }); // Listen for `tbwfocus` event
						.on("tbwchange", function(){
							console.log("Blur!");
							$( ".vwi_ui_elementchange" ).change();

						}); // Listen for `tbwblur` event
					});
				})(jQuery);
			</script>';
			return $s;

		break;
		case "select":


			$params["class"].=" wiv_ui_param_value";

			return spxForm::select($params);
		break;
		case "select2":
			/*

			$a = spxRequest::get_tvlineup ();
			$amedia_type_lineup = spxRequest::get_media_type_lineup (true);

			$c["placeholder"]="Select a media lineup";
			foreach($a as $key => $value) {
				$mt = $amedia_type_lineup[$value["tv_lineup_media_type_id"]];
				$c[$value["tv_lineup_id"]]=$value["tv_lineup_name"]." (".$mt["media_type_name"].")";
			}
			$slineupcopy = spxForm::select2 (array(data => $c, "class" => "form-control needselect2", "name" => "tv_lineup_id"));

			*/

			/*

			.col-state-grey-dark10 {
				background-color:#eceff1!important;
			}

			$color = array();
$color["red"]="red";
$color["green"]="green";


$colorclass = array();
$colorclass["red"]="col-state-red";
$colorclass["green"]="col-state-green";


$stvright_color = spxForm::select2 (array(data => $color, dataclass => $colorclass, selected => $a[0]["tv_right_state_color"], "class" => "w100 needselect2", "name" => "tv_right_state_color"));


			*/

			//print_r($params);

			$params["class"].=" wiv_ui_param_value needselect2";
			//$params["style"].=" background-color:'#eceff1;'";

			return spxForm::select2($params);
		break;
		case "select2group":
			$params["class"].=" wiv_ui_param_value";
			return spxForm::select2group($params);
		break;
		case "colordefault":
		case "colornodefault":

			// "base"=>       "#e51c23",
			//'#e51c23' =>  'base,
			//'#e51c23' => 'background-color:#e51c23;',
			$bdefault = true;
			if ($type == "colornodefault") $bdefault = false;
			$a = spxdisplayForm::getColorConfigformName($bdefault);
			$b = spxdisplayForm::getColorConfigformBackground($bdefault);


			$class = $params["class"];
			$params["class"].=" wiv_ui_param_value needselect2 colorneeddarkandlight";

			$params["data"] = $a;
			$params["datastyle"] = $b;

			$s = "";
			$s .=  spxForm::select2group($params);


			$param_name = $params["name"];
			$params["name"] = $param_name."_dark";
			$params['value'] = "xxx";
			$s .=  spxForm::hidden($params);
			$params["name"] = $param_name."_light";
			$params['value'] = "yyy";
			$s .=  spxForm::hidden($params);




			return $s;

		break;
		case "sliderMinMax":
			$id = "id_".$params["name"];
			//$id = "toto";
			$step = !empty($params["step"])? floatval($params["step"]): 1;

			$min = floatval($params["min"]);
			$max = floatval($params["max"]);
			$count = strlen((string)$max);
			$params["size"] = $count;
			$params["maxlength"] = $count;
			$params["id"] = $id;
			if ($params["value"]=="") $params["value"]=$min;
			$value = $params["value"];
			$params["readonly"]= true;
			// $id, $name.'[]', $value, 'text', $count.'-'.$count,true
			$s = spxForm::text ($params);
			$s .= '<div id="slider-'.$id.'" style="width:100%;margin-top:10px;" ></div>';

			$s.="\n\t".'<script>';
				$s.="\n\t".'$(document).ready(function() {';

					$s.="\n\t".'$("#slider-'.$id.'").slider(
					{
					  range: "min",
					  min: '.$min.',
					  max: '.$max.',
					step: '.$step.',
					  value: '.$value.',
					  slide: function( event, ui ) {
						$( "#'.$id.'" ).val( ui.value );
						$( ".vwi_ui_elementchange" ).change();
					  }
					}


					);';

				$s.=	"\n\t".'});';
			$s.="\n\t".'</script>';


			return $s;

		break;
		// instance string drag and drop
		case "idd":

			$id = "id_".$params["name"];
			$params["id"]=$id;
			$s.= spxForm::hidden($params);
			$s.= '<div id="idd-'.$id.'" ></div>';
			$s.="\n\t".'<script>';
				$s.="\n\t".'$(document).ready(function() {';
					$s.="\n\t".'console.log("ok !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!")';
					//$s.="\n\t".'var refidd = ';
					$s.="\n\t".'$(".vwi_ui-modal-container-content #idd-'.$id.'").viwidd({

						field: "#'.$id.'",


					}).data("viwidd");

					';

				$s.=	"\n\t".'});';
			$s.="\n\t".'</script>';
			return $s;


		break;
		// child widget drag and drop
		case "cwdd":
		/*echo ("<pre>");
		print_r($params["child"]->parent->name);
		echo ("</pre>");*/

		//print_r($params["child"]["parent"]["name"]);

			$id = "id_".$params["name"];
			$params["value"] = stripslashes ($params["value"]);
			// viw_ui-fieldgroup-content should be invisible
			// get the content div is : ".vwi_ui-modal-container-content #id_".$params["param_name"]
			//echo ("div where content is = .vwi_ui-modal-container-content #id_".$params["param_name"]."\n<br>");
			//echo ("div where jq should create is = .vwi_ui-modal-container-content #tab-".$params["child"]->name."\n<br>");
			// should create the jquery object in tab : tab-'.$stabid -> child name $params["child"]["name"]
			$params["readonly"]=true;
			$s = spxForm::textarea($params);

			$s.="\n\t".'<script>';
				$s.="\n\t".'$(document).ready(function() {';
					//$s.="\n\t".'console.log(" ready to build object ")';
					//$s.="\n\t".'console.log($(".vwi_ui-modal-container-content #id_'.$params["param_name"].'").val())';
					//$s.="\n\t".'$(".vwi_ui-modal-container-content #tab-'.$params["child"]->name.'").html("coucou")';

					$s.="\n\t".'$(".vwi_ui-modal-container-content #tab-'.$params["child"]->name.'").viwcwdd({

						field: "#'.$id.'",
						cwname: "'.$params["child"]->name.'",
						default_options: '.json_encode($params["child"]->default_options).',
						parent_name: "'.$params["child"]->parent->name.'"

					}).data("viwcwdd");

					';


				$s.=	"\n\t".'});';
			$s.="\n\t".'</script>';

			return $s;


		break;
		case "hidden":
			//$params["value"] = stripslashes ($params["value"]);
			return spxForm::hidden($params);
		break;
		case "text":
			//$params["value"] = stripslashes ($params["value"]);
			return spxForm::text($params);
		break;
		default:
			$params["value"] = stripslashes ($params["value"]);
			return spxForm::text($params);
		break;
		}


	}

	# return a html field
	/*
	public static function getHTMLfieldTEST($acolumn,$avalue,$number_id) {

		$aoption = $acolumn["option"];
		$name=$acolumn["name"];
		$reado=$acolumn["reado"];
		$value=$avalue["value"];
		$type = $aoption[0];

		switch ($type) {
		case "xxx":
		break;

		default:
			if ( $aoption[1]=="")  $aoption[1]=10;
				if ( $aoption[2]=="")  $aoption[2]=20;
				return (spxdatasUtils::printInput ($name.'[]', $value, 'text', $aoption[1]."-".$aoption[2],$reado));

			}
		break;
	}
	*/
}
?>